//
//  AddNewSourceController.h
//  Gi2MO Monitor
//
//  Created by cyanide on 2/25/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "IdeaManagementStatus.h"
#import "HistoryDataController.h"

@class AddNewSourceController;

@protocol AddNewSourceControllerDelegate
- (void)addNewSourceControllerDidFinishAdd:(AddNewSourceController *)controller;
- (void)addNewSourceControllerDidFinishCancel:(AddNewSourceController *)controller;
@end

@interface AddNewSourceController : UIViewController <UITableViewDataSource, UITableViewDelegate> 
{
    IBOutlet UITextField *imsSourceUrl;
    IBOutlet UIButton *addButton;
    
    //preview text
	IBOutlet UILabel	*imsNameTitle;
	IBOutlet UILabel	*imsName;
	IBOutlet UILabel	*ideaNumberTitle;
	IBOutlet UILabel	*commentNumberTitle;
	IBOutlet UILabel	*ideaNumber;
	IBOutlet UILabel	*commentNumber;
    
    //parsed Data
    IdeaManagementStatus *ideaManagementStatusData;

    //source history (stored with core data)
    HistoryDataController *historyDataController;
    IBOutlet UITableView *historyTableView;
    int i;
    NSManagedObjectContext *managedObjectContext;

}

@property (assign, nonatomic) IBOutlet id <AddNewSourceControllerDelegate> delegate;

@property (nonatomic, retain) UITextField *imsSourceUrl;

@property (nonatomic, retain) UILabel *imsNameTitle;
@property (nonatomic, retain) UILabel *imsName;
@property (nonatomic, retain) UILabel *ideaNumberTitle;
@property (nonatomic, retain) UILabel *commentNumberTitle;
@property (nonatomic, retain) UILabel *ideaNumber;
@property (nonatomic, retain) UILabel *commentNumber;

@property (nonatomic, retain) UIButton *addButton;

@property (nonatomic, retain) IdeaManagementStatus *ideaManagementStatusData;

//source history properties (core data)
@property (nonatomic, retain) HistoryDataController *historyDataController;
@property (nonatomic, retain) UITableView *historyTableView;
@property (nonatomic, retain) NSManagedObjectContext *managedObjectContext;

//button events
- (IBAction)cancel:(id)sender;
- (IBAction)test:(id)sender;
- (IBAction)add:(id)sender;

//keyboard events
-(IBAction) backgroundTap:(id) sender;

@end
