//
//  AddNewSourceController.m
//  Gi2MO Monitor
//
//  Created by cyanide on 2/25/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "AddNewSourceController.h"
#import "XMLReader.h"
#import "SourceHistory.h"

@implementation AddNewSourceController

@synthesize delegate = _delegate;

@synthesize	imsSourceUrl;

@synthesize	imsNameTitle;
@synthesize	imsName;
@synthesize	ideaNumberTitle;
@synthesize	commentNumberTitle;
@synthesize	ideaNumber;
@synthesize	commentNumber;

@synthesize addButton;

@synthesize	ideaManagementStatusData;

//source history properties
@synthesize historyDataController;
@synthesize historyTableView;

//core data
@synthesize managedObjectContext;

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    self.historyDataController = [[HistoryDataController alloc] init:self.managedObjectContext];
    [historyTableView reloadData];
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    //#warning Potentially incomplete method implementation.
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    //#warning Incomplete method implementation.
    // Return the number of rows in the section.
    //return 2;
    return [historyDataController countOfList];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
    }
    
    // Configure the cell...
    
    //Retreive text from datasource, the -1 accounts for the first element being hardcoded to say new Item
    //cell.textLabel.text = @"dupa"; //[dataController objectInListAtIndex:indexPath.row];
    //cell.textLabel.text = [NSString stringWithFormat:@"dupa - (%i)", i];
    SourceHistory *historyObject = [historyDataController objectInListAtIndex:indexPath.row];
    cell.textLabel.text = historyObject.title;
    cell.detailTextLabel.font = [UIFont systemFontOfSize: 12];
    cell.detailTextLabel.text = historyObject.url;
    
    return cell;
}


// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the specified item to be editable.
    //return YES;
    return UITableViewCellEditingStyleDelete;
}



// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        // Delete the row from the data source
        [historyDataController removeDataAtIndex:indexPath.row];
        [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
    }   
    else if (editingStyle == UITableViewCellEditingStyleInsert) {
        // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
    }   
}


// Override to support rearranging the table view.
- (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
{
}

// Override to support conditional rearranging of the table view.
- (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Return NO if you do not want the item to be re-orderable.
    return YES;
}

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     [detailViewController release];
     */
    SourceHistory *historyObject = [historyDataController objectInListAtIndex:indexPath.row];
    imsSourceUrl.text = historyObject.url;
    //test if the source is still working
    [self test: self];
}

// ---------------------------------------------------------------
// ---------------------------------------------------------------
// ---------------------------------------------------------------

#pragma mark - Actions

- (IBAction)cancel:(id)sender
{
    ideaManagementStatusData = nil;
    [self.delegate addNewSourceControllerDidFinishCancel:self];
}

- (IBAction)test:(id)sender
{
    //fetch data from the text box
    //NSString *url = ;
    
    //connect to the datasource and parse the rdf/xml file
    NSString *u = [NSString stringWithFormat:imsSourceUrl.text];
    //    NSString *u = [NSString stringWithFormat:@"http://192.168.1.33/~cyanide/gi2mo_ideas666.rdf"];
    //    NSString *u = [NSString stringWithFormat:@"http://192.168.1.33/~cyanide/gi2mo_ideas.rdf"];
    NSURLRequest* chRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:u] cachePolicy: NSURLRequestReloadIgnoringCacheData timeoutInterval:10];
    NSError* theError;
    NSData* response = [NSURLConnection sendSynchronousRequest:chRequest returningResponse:nil error:&theError]; 
    
    NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithData:response];
    
    //hide keyboard
    [sender resignFirstResponder];

    //enable namespace parsing
    [xmlParser setShouldProcessNamespaces:YES];
    
    //Initialize the delegate.
    XMLReader *parser = [[XMLReader alloc] initXMLReader];
    
    //Set delegate
    [xmlParser setDelegate:parser];
    
    //Start parsing the XML file.
    BOOL success = [xmlParser parse];
    
    if(success && response!= nil)
    {
        NSLog(@"No Errors (Test Url)");
        
        ideaManagementStatusData = parser.ideaManagementStatus;
        ideaManagementStatusData.imsURI = imsSourceUrl.text;
        //set new values
        imsName.text = parser.ideaManagementStatus.title;
        ideaNumber.text = parser.ideaManagementStatus.hasIdeaCount;
        commentNumber.text = parser.ideaManagementStatus.hasCommentCount;
        
        imsName.textAlignment = UITextAlignmentLeft;
        
        //show values
        imsNameTitle.hidden = FALSE;
        imsName.hidden = FALSE;
        ideaNumberTitle.hidden = FALSE;
        commentNumberTitle.hidden = FALSE;
        ideaNumber.hidden = FALSE;
        commentNumber.hidden = FALSE;
        
        addButton.enabled = TRUE;
        addButton.alpha = 1;
    }
    else
    {
        NSLog(@"Connection Error (Test Url)");
        
        ideaManagementStatusData = nil;
        
        imsName.text = @"CONNECTION ERROR";
        imsName.textAlignment = UITextAlignmentCenter;
        //imsName.textColor = [UIColor colorWithRed:198.0 green:0.0 blue:0.0 alpha:0.7];
        //imsName.font = [UIFont systemFontOfSize: 15];
        //        imsName.font = [UIFont boldSystemFontOfSize:0];

        //hide preview 
        imsNameTitle.hidden = TRUE;
        imsName.hidden = FALSE;
        ideaNumberTitle.hidden = TRUE;
        commentNumberTitle.hidden = TRUE;
        ideaNumber.hidden = TRUE;
        commentNumber.hidden = TRUE;
        
        addButton.enabled = FALSE;
        addButton.alpha = 0.7;
        addButton.titleLabel.textColor = [UIColor colorWithRed:180.0 green:188.0 blue:184.0 alpha:1.0];
    }

    
}

- (IBAction)add:(id)sender
{
    [historyDataController addSourceHistory:ideaManagementStatusData.title withUrl:ideaManagementStatusData.imsURI];
    [self.delegate addNewSourceControllerDidFinishAdd:self];
}

-(IBAction) backgroundTap:(id) sender{
    [self.imsSourceUrl resignFirstResponder];
}


@end
