//
//  DataControler.m
//  Gi2MO Monitor
//
//  Created by cyanide on 2/22/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "DataController.h"
#import "IMS.h"
#import "Idea.h"
#import "User.h"
#import "Contest.h"
#import "Comment.h"
#import "IdeaManagementStatus.h"
#import "ImsHistory.h"

@implementation DataController

@synthesize list;
@synthesize context;

- (unsigned) countOfList
{
    return [list count];
}

- (id)objectInListAtIndex:(unsigned)theIndex 
{
    if (theIndex >= [self countOfList]) 
        return nil;
    else
        return [list objectAtIndex:theIndex];
}

- (void)removeDataAtIndex:(unsigned)theIndex
{
    //remove data from core data storge
    IMS *imsObject = [list objectAtIndex:theIndex];
    [context deleteObject:imsObject];
    
    NSError *error;
    if (![context save:&error]) {   //attempt to commit changes
        NSLog(@"Whoops, couldn't save: %@", [error localizedDescription]);
    }
    else //if no error then remove object from the list
    [list removeObjectAtIndex:theIndex]; 
}

- (void)addData:(IdeaManagementStatus*)data;
{
    //save data to core data storage
    IMS *managedObjectOfIMS = [NSEntityDescription
                               insertNewObjectForEntityForName:@"IMS" 
                               inManagedObjectContext:context];
    
    managedObjectOfIMS.title = data.title; //@"GSI Ideas666";
    managedObjectOfIMS.url = data.imsURI; //@"http://gsi.gi2mo.org/";
    managedObjectOfIMS.dateAdded = [NSDate date];
    managedObjectOfIMS.hasIdeaCount = [NSNumber numberWithInt:[data.hasIdeaCount intValue]];
    managedObjectOfIMS.hasCommentCount = [NSNumber numberWithInt:[data.hasCommentCount intValue]];
    managedObjectOfIMS.hasContestCount = [NSNumber numberWithInt:[data.hasContestCount intValue]];
    managedObjectOfIMS.hasReviewCount = [NSNumber numberWithInt:[data.hasReviewCount intValue]];
    //set previous data the same as current
    managedObjectOfIMS.previousDateAdded = managedObjectOfIMS.dateAdded;
    managedObjectOfIMS.previousIdeaCount = managedObjectOfIMS.hasIdeaCount;
    managedObjectOfIMS.previousCommentCount = managedObjectOfIMS.hasCommentCount;
    managedObjectOfIMS.previousContestCount = managedObjectOfIMS.hasContestCount;
    managedObjectOfIMS.previousReviewCount = managedObjectOfIMS.hasReviewCount;
    
    User *managedObjectOfUser = [NSEntityDescription
                                 insertNewObjectForEntityForName:@"User" 
                                 inManagedObjectContext:context];

    //set ims history value counts
    ImsHistory *managedObjectOfImsHistory = [NSEntityDescription
                                 insertNewObjectForEntityForName:@"ImsHistory" 
                                 inManagedObjectContext:context];
    
    managedObjectOfImsHistory.dayIdeaCount = [NSNumber numberWithInt:[data.hasIdeaCountLastDay intValue]];
    managedObjectOfImsHistory.dayCommentCount = [NSNumber numberWithInt:[data.hasCommentCountLastDay intValue]];
    managedObjectOfImsHistory.dayContestCount = [NSNumber numberWithInt:[data.hasContestCountLastDay intValue]];
    managedObjectOfImsHistory.dayReviewCount = [NSNumber numberWithInt:[data.hasReviewCountLastDay intValue]];

    managedObjectOfImsHistory.weekIdeaCount = [NSNumber numberWithInt:[data.hasIdeaCountLastWeek intValue]];
    managedObjectOfImsHistory.weekCommentCount = [NSNumber numberWithInt:[data.hasCommentCountLastWeek intValue]];
    managedObjectOfImsHistory.weekContestCount = [NSNumber numberWithInt:[data.hasContestCountLastWeek intValue]];
    managedObjectOfImsHistory.weekReviewCount = [NSNumber numberWithInt:[data.hasReviewCountLastWeek intValue]];

    managedObjectOfImsHistory.monthIdeaCount = [NSNumber numberWithInt:[data.hasIdeaCountLastMonth intValue]];
    managedObjectOfImsHistory.monthCommentCount = [NSNumber numberWithInt:[data.hasCommentCountLastMonth intValue]];
    managedObjectOfImsHistory.monthContestCount = [NSNumber numberWithInt:[data.hasContestCountLastMonth intValue]];
    managedObjectOfImsHistory.monthReviewCount = [NSNumber numberWithInt:[data.hasReviewCountLastMonth intValue]];

    managedObjectOfImsHistory.yearIdeaCount = [NSNumber numberWithInt:[data.hasIdeaCountLastYear intValue]];
    managedObjectOfImsHistory.yearCommentCount = [NSNumber numberWithInt:[data.hasCommentCountLastYear intValue]];
    managedObjectOfImsHistory.yearContestCount = [NSNumber numberWithInt:[data.hasContestCountLastYear intValue]];
    managedObjectOfImsHistory.yearReviewCount = [NSNumber numberWithInt:[data.hasReviewCountLastYear intValue]];
    
    managedObjectOfImsHistory.hasIMS = managedObjectOfIMS;
    managedObjectOfIMS.hasHistory = managedObjectOfImsHistory;

    
    //set Idea
    managedObjectOfUser.accountName = data.ideaAuthor;
    
    Idea *managedObjectOfIdea = [NSEntityDescription
                                 insertNewObjectForEntityForName:@"Idea" 
                                 inManagedObjectContext:context];
    
    managedObjectOfIdea.created = data.ideaDate;
    managedObjectOfIdea.title = data.ideaTitle;
    managedObjectOfIdea.hasIMSInstance = managedObjectOfIMS;
    managedObjectOfIdea.hasCreator = managedObjectOfUser;
    managedObjectOfIMS.hasIdea = managedObjectOfIdea;
    managedObjectOfUser.isCreatorOfIdea = managedObjectOfIdea;
    
    //set Comment
    managedObjectOfUser = [NSEntityDescription
                                 insertNewObjectForEntityForName:@"User" 
                                 inManagedObjectContext:context];
    
    managedObjectOfUser.accountName = data.commentAuthor;

    Comment *managedObjectOfComment = [NSEntityDescription
                                 insertNewObjectForEntityForName:@"Comment" 
                                 inManagedObjectContext:context];
    
    managedObjectOfComment.created = data.commentDate;
    managedObjectOfComment.content = data.commentText;
    managedObjectOfComment.hasIMSInstance = managedObjectOfIMS;
    managedObjectOfComment.hasCreator = managedObjectOfUser;
    managedObjectOfIMS.hasIdea = managedObjectOfIdea;
    managedObjectOfUser.isCreatorOfComment = managedObjectOfComment;

    //set Contest
    managedObjectOfUser = [NSEntityDescription
                           insertNewObjectForEntityForName:@"User" 
                           inManagedObjectContext:context];
    
    managedObjectOfUser.accountName = data.contestAuthor;
    
    Contest *managedObjectOfContest = [NSEntityDescription
                                       insertNewObjectForEntityForName:@"Contest" 
                                       inManagedObjectContext:context];
    
    managedObjectOfContest.created = data.contestDate;
    managedObjectOfContest.title = data.contestTitle;
    managedObjectOfContest.hasIMSInstance = managedObjectOfIMS;
    managedObjectOfContest.hasCreator = managedObjectOfUser;
    managedObjectOfIMS.hasIdea = managedObjectOfIdea;
    managedObjectOfUser.isCreatorOfContest = managedObjectOfContest;
        
    NSError *error;
    if (![context save:&error]) {
        NSLog(@"Whoops, couldn't save: %@", [error localizedDescription]);
    } else //if no errors then add object to list
        [list addObject:managedObjectOfIMS];
}

- (void) updateData: (IdeaManagementStatus*) data AtIndex: (unsigned) theIndex
{
    IMS *ims = [list objectAtIndex:theIndex];
    
    ims.title = data.title;
    
    //ims.url = parser.ideaManagementStatus.imsURI; //@"http://gsi.gi2mo.org/";

    //save old data 
    ims.previousDateAdded = ims.dateAdded;
    ims.previousIdeaCount = ims.hasIdeaCount;
    ims.previousCommentCount = ims.hasCommentCount;
    ims.previousContestCount = ims.hasContestCount;
    ims.previousReviewCount = ims.hasReviewCount;
    
    //set new values
    ims.dateAdded = [NSDate date];
    ims.hasIdeaCount = [NSNumber numberWithInt:[data.hasIdeaCount intValue]];
    ims.hasCommentCount = [NSNumber numberWithInt:[data.hasCommentCount intValue]];
    ims.hasContestCount = [NSNumber numberWithInt:[data.hasContestCount intValue]];
    ims.hasReviewCount = [NSNumber numberWithInt:[data.hasReviewCount intValue]];
    
    //IMS History
    ims.hasHistory.dayIdeaCount = [NSNumber numberWithInt:[data.hasIdeaCountLastDay intValue]];
    ims.hasHistory.dayCommentCount = [NSNumber numberWithInt:[data.hasCommentCountLastDay intValue]];
    ims.hasHistory.dayContestCount = [NSNumber numberWithInt:[data.hasContestCountLastDay intValue]];
    ims.hasHistory.dayReviewCount = [NSNumber numberWithInt:[data.hasReviewCountLastDay intValue]];
    
    ims.hasHistory.weekIdeaCount = [NSNumber numberWithInt:[data.hasIdeaCountLastWeek intValue]];
    ims.hasHistory.weekCommentCount = [NSNumber numberWithInt:[data.hasCommentCountLastWeek intValue]];
    ims.hasHistory.weekContestCount = [NSNumber numberWithInt:[data.hasContestCountLastWeek intValue]];
    ims.hasHistory.weekReviewCount = [NSNumber numberWithInt:[data.hasReviewCountLastWeek intValue]];
    
    ims.hasHistory.monthIdeaCount = [NSNumber numberWithInt:[data.hasIdeaCountLastMonth intValue]];
    ims.hasHistory.monthCommentCount = [NSNumber numberWithInt:[data.hasCommentCountLastMonth intValue]];
    ims.hasHistory.monthContestCount = [NSNumber numberWithInt:[data.hasContestCountLastMonth intValue]];
    ims.hasHistory.monthReviewCount = [NSNumber numberWithInt:[data.hasReviewCountLastMonth intValue]];
    
    ims.hasHistory.yearIdeaCount = [NSNumber numberWithInt:[data.hasIdeaCountLastYear intValue]];
    ims.hasHistory.yearCommentCount = [NSNumber numberWithInt:[data.hasCommentCountLastYear intValue]];
    ims.hasHistory.yearContestCount = [NSNumber numberWithInt:[data.hasContestCountLastYear intValue]];
    ims.hasHistory.yearReviewCount = [NSNumber numberWithInt:[data.hasReviewCountLastYear intValue]];
    
    //set Idea
    ims.hasIdea.hasCreator.accountName = data.ideaAuthor;  
    ims.hasIdea.created = data.ideaDate;
    ims.hasIdea.title = data.ideaTitle;
    
    //set Comment
    
    ims.hasComment.hasCreator.accountName = data.commentAuthor; 
    ims.hasComment.created = data.commentDate;
    ims.hasComment.content = data.commentText;
    
    
    //set Contest        
    ims.hasContest.hasCreator.accountName = data.contestAuthor;        
    ims.hasContest.created = data.contestDate;
    ims.hasContest.title = data.contestTitle;
    
    NSError *error;
    if (![context save:&error]) {
        NSLog(@"Whoops, couldn't update: %@", [error localizedDescription]);
    }
}

- (void) moveObjectAtIndex: (unsigned) index1 toIndex: (unsigned) index2
{
    //move object in the list
    IMS *ims;
    ims = [self objectInListAtIndex:index1];
    [list removeObjectAtIndex: index1];
    [list insertObject: ims atIndex: index2];
    NSLog(@"ims title test: %@",ims.title);
    //update indexNumber in the database

    for (unsigned i = 0; i < [self countOfList]; i++) {
        ims = [self objectInListAtIndex:i];
        ims.indexNumber = [NSNumber numberWithInt: i];
    }
    // save into database
    NSError *error;
    if (![context save:&error]) {
        NSLog(@"Whoops, couldn't update: %@", [error localizedDescription]);
    }
}

//- (void)addData:(NSString*)data;
//{
//    //save data to core data storage
//    IMS *managedObjectOfIMS = [NSEntityDescription
//                               insertNewObjectForEntityForName:@"IMS" 
//                               inManagedObjectContext:context];
//    managedObjectOfIMS.title = data; //@"GSI Ideas666";
//    managedObjectOfIMS.url = @"http://gsi.gi2mo.org/";
//    managedObjectOfIMS.dateAdded = [NSDate date];
//    managedObjectOfIMS.hasIdeaCount = [NSNumber numberWithInt:1];
//    managedObjectOfIMS.hasCommentCount = [NSNumber numberWithInt:2];
//    managedObjectOfIMS.hasContestCount = [NSNumber numberWithInt:3];
//    managedObjectOfIMS.hasReviewCount = [NSNumber numberWithInt:4];
//    
//    NSError *error;
//    if (![context save:&error]) {
//        NSLog(@"Whoops, couldn't save: %@", [error localizedDescription]);
//    } else //if no errors then add object to list
//    [list addObject:managedObjectOfIMS];
//}

// Custom set accessor to ensure the new list is mutable
- (void)setList:(NSMutableArray *)newList 
{
    if (list != newList) 
    {
            [list release];
            list = [newList mutableCopy];
    }
}

- (id)init:(NSManagedObjectContext *)managedObjectContext
{
    if (self = [super init]) 
    {
        //set core data context
        self.context = managedObjectContext;
        //Instantiate list
        NSMutableArray *localList = [[NSMutableArray alloc] init];
        self.list = localList;
        [localList release];

        //Add initial Data
        //[self addData:@"Item 1"];
        //[self addData:@"Item 2"];
        
        //fetch data from database
        NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
        NSEntityDescription *entity = [NSEntityDescription 
                                       entityForName:@"IMS" inManagedObjectContext:context];
        [fetchRequest setEntity:entity];
        
        NSSortDescriptor *sortDescriptor = [[NSSortDescriptor alloc]
                                            initWithKey:@"indexNumber" ascending:YES];
        [fetchRequest setSortDescriptors:[NSArray arrayWithObject:sortDescriptor]];
        [sortDescriptor release];
        
        NSError *error;
        self.list = [[context executeFetchRequest:fetchRequest error:&error] mutableCopy];
        [fetchRequest release];
    }
    return self;
}


- (void)dealloc 
{
    [list release];
    context = nil;
    [super dealloc];
}

@end
