//
//  RefreshImageAnimationOperation.m
//  Gi2MO Monitor
//
//  Created by cyanide on 3/3/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "FetchRDFOperation.h"

#import "XMLReader.h"
#import "IdeaManagementStatus.h"

@implementation FetchRDFOperation

@synthesize imsStatus;
@synthesize url;
@synthesize pageNumber;

- (void)main {

    imsStatus = nil;
    if (url != nil)
        [self fetchRDFStatistics];
    
    if (NO==[[NSThread currentThread] isCancelled]){
        // Make sure we sending a number
        if (nil==imsStatus)
        {
            imsStatus = [[IdeaManagementStatus alloc] init];
            imsStatus.transferSuccess = NO;
        } else 
            imsStatus.transferSuccess = YES;

        NSDictionary *userInfo = [NSDictionary dictionaryWithObject:imsStatus forKey:[NSString stringWithFormat:@"rdfDownloadFinished forStatusPage: %d", pageNumber]];
        [[NSNotificationCenter defaultCenter] postNotificationName:[NSString stringWithFormat:@"rdfDownloadFinished forStatusPage: %d", pageNumber]
                                                            object:self 
                                                          userInfo: userInfo];
    }
}

- (void) fetchRDFStatistics
{

    //IMS *ims = [dataController objectInListAtIndex: pageNumber];
        
    //alternative with timeout
    
    //NSString *u = [NSString stringWithFormat:@"http://ideas.gi2mo.org/gi2mo_ideas666.rdf"];
    
    //NSString *u = ims.url; //[NSString stringWithFormat:@"%@",ims.url];

    NSURLRequest* chRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:url] cachePolicy: NSURLRequestReloadIgnoringCacheData timeoutInterval:1000];
    NSError* theError;
    NSData* response = [NSURLConnection sendSynchronousRequest:chRequest returningResponse:nil error:&theError]; 
    
    NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithData:response];
    
    //enable namespace parsing
    [xmlParser setShouldProcessNamespaces:YES];
    
    //Initialize the delegate.
    XMLReader *parser = [[XMLReader alloc] initXMLReader];
    
    //Set delegate
    [xmlParser setDelegate:parser];
    
    //Start parsing the XML file.
    BOOL success = [xmlParser parse];
    
    if(success && response!= nil)
    {
        NSLog(@"No Errors in da thread");
        imsStatus = parser.ideaManagementStatus;
    }
    else
    {
        NSLog(@"Error Error Error in da thread!!!");
        imsStatus = nil;
    }
}

- (void)dealloc {
    [imsStatus release], imsStatus = nil;
    [super dealloc];
}


@end
