//
//  FlipsideViewController.m
//  Gi2MO Monitor
//
//  Created by cyanide on 2/18/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "FlipsideViewController.h"
#import "DataController.h"
#import "IMS.h"
#import "Settings.h"

@implementation FlipsideViewController

@synthesize delegate = _delegate;
@synthesize dataController;
@synthesize applicationSettings;
@synthesize imsTableView;
@synthesize autorefreshControl;
@synthesize differenceCalcControl;

@synthesize listDidChange;

//core data
@synthesize managedObjectContext;

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

/*
- (void)loadView
{   
    imsTableView = [[UITableView alloc] initWithFrame:[[UIScreen mainScreen] applicationFrame]
                                                          style:UITableViewStylePlain];
    imsTableView.autoresizingMask = UIViewAutoresizingFlexibleHeight|UIViewAutoresizingFlexibleWidth;
    imsTableView.delegate = self;
    imsTableView.dataSource = self;
    [imsTableView reloadData];
    
    self.view = imsTableView;
    [imsTableView release];
} */

- (void)viewDidLoad
{
    [super viewDidLoad];
    imsTableView.editing = YES;
    i = 1;
    self.dataController = [[DataController alloc] init:self.managedObjectContext];
    
    //get application settings
    [autorefreshControl setSelectedSegmentIndex: [applicationSettings.autorefreshType intValue]];
    [differenceCalcControl setSelectedSegmentIndex: [applicationSettings.diffMode intValue]];
    
    [imsTableView reloadData]; 
    listDidChange = NO;
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}


#pragma mark - Table view data source

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
//#warning Potentially incomplete method implementation.
    // Return the number of sections.
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
//#warning Incomplete method implementation.
    // Return the number of rows in the section.
    //return 2;
    return [dataController countOfList];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *CellIdentifier = @"Cell";
    
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) {
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleSubtitle reuseIdentifier:CellIdentifier] autorelease];
    }
    
    // Configure the cell...
    
    //Retreive text from datasource, the -1 accounts for the first element being hardcoded to say new Item
    //cell.textLabel.text = @"dupa"; //[dataController objectInListAtIndex:indexPath.row];
    //cell.textLabel.text = [NSString stringWithFormat:@"dupa - (%i)", i];
    IMS *imsObject = [dataController objectInListAtIndex:indexPath.row];
    cell.textLabel.text = imsObject.title;
    cell.detailTextLabel.font = [UIFont systemFontOfSize: 12];
    cell.detailTextLabel.text = imsObject.url;
    
    return cell;
}


// Override to support conditional editing of the table view.
- (BOOL)tableView:(UITableView *)tableView canEditRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the specified item to be editable.
 //return YES;
     return UITableViewCellEditingStyleDelete;
 }



// Override to support editing the table view.
- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath
 {
 if (editingStyle == UITableViewCellEditingStyleDelete) {
 // Delete the row from the data source
 [dataController removeDataAtIndex:indexPath.row];
 [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
     listDidChange = YES;
 }   
 else if (editingStyle == UITableViewCellEditingStyleInsert) {
 // Create a new instance of the appropriate class, insert it into the array, and add a new row to the table view
 }   
 }


 // Override to support rearranging the table view.
 - (void)tableView:(UITableView *)tableView moveRowAtIndexPath:(NSIndexPath *)fromIndexPath toIndexPath:(NSIndexPath *)toIndexPath
 {
     [dataController moveObjectAtIndex: fromIndexPath.row toIndex: toIndexPath.row];
     listDidChange = YES;
 }

 // Override to support conditional rearranging of the table view.
 - (BOOL)tableView:(UITableView *)tableView canMoveRowAtIndexPath:(NSIndexPath *)indexPath
 {
 // Return NO if you do not want the item to be re-orderable.
 return YES;
 }

#pragma mark - Table view delegate

- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
{
    // Navigation logic may go here. Create and push another view controller.
    /*
     <#DetailViewController#> *detailViewController = [[<#DetailViewController#> alloc] initWithNibName:@"<#Nib name#>" bundle:nil];
     // ...
     // Pass the selected object to the new view controller.
     [self.navigationController pushViewController:detailViewController animated:YES];
     [detailViewController release];
     */
}

// ---------------------------------------------------------------
// ---------------------------------------------------------------
// ---------------------------------------------------------------

//#pragma mark -
//#pragma mark Fetched results controller
//
///**
// Returns the fetched results controller. Creates and configures the controller if necessary.
// */
//- (NSFetchedResultsController *)fetchedResultsController {
//    
//    if (fetchedResultsController != nil) {
//        return fetchedResultsController;
//    }
//    
//    // Create and configure a fetch request with the Book entity.
//    NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
//    NSEntityDescription *entity = [NSEntityDescription entityForName:@"IMS" inManagedObjectContext:managedObjectContext];
//    [fetchRequest setEntity:entity];
//    
//    // Create the sort descriptors array.
//    NSSortDescriptor *dateAddedDescriptor = [[NSSortDescriptor alloc] initWithKey:@"dateAdded" ascending:NO];
//    NSSortDescriptor *titleDescriptor = [[NSSortDescriptor alloc] initWithKey:@"title" ascending:YES];
//    NSArray *sortDescriptors = [[NSArray alloc] initWithObjects:dateAddedDescriptor, titleDescriptor, nil];
//    [fetchRequest setSortDescriptors:sortDescriptors];
//    
//    // Create and initialize the fetch results controller.
//    NSFetchedResultsController *aFetchedResultsController = [[NSFetchedResultsController alloc] initWithFetchRequest:fetchRequest managedObjectContext:managedObjectContext sectionNameKeyPath:nil cacheName:@"Root"];
//    self.fetchedResultsController = aFetchedResultsController;
//    fetchedResultsController.delegate = self;
//    
//    // Memory management.
//    [aFetchedResultsController release];
//    [fetchRequest release];
//    [dateAddedDescriptor release];
//    [titleDescriptor release];
//    [sortDescriptors release];
//    
//    return fetchedResultsController;
//}    
//
//
///**
// Delegate methods of NSFetchedResultsController to respond to additions, removals and so on.
// */
//
//- (void)controllerWillChangeContent:(NSFetchedResultsController *)controller {
//    // The fetch controller is about to start sending change notifications, so prepare the table view for updates.
//    [self.tableView beginUpdates];
//}
//
//
//- (void)controller:(NSFetchedResultsController *)controller didChangeObject:(id)anObject atIndexPath:(NSIndexPath *)indexPath forChangeType:(NSFetchedResultsChangeType)type newIndexPath:(NSIndexPath *)newIndexPath {
//    
//    UITableView *tableView = self.tableView;
//    
//    switch(type) {
//            
//        case NSFetchedResultsChangeInsert:
//            [tableView insertRowsAtIndexPaths:[NSArray arrayWithObject:newIndexPath] withRowAnimation:UITableViewRowAnimationFade];
//            break;
//            
//        case NSFetchedResultsChangeDelete:
//            [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
//            break;
//            
//        case NSFetchedResultsChangeUpdate:
//            [self configureCell:[tableView cellForRowAtIndexPath:indexPath] atIndexPath:indexPath];
//            break;
//            
//        case NSFetchedResultsChangeMove:
//            [tableView deleteRowsAtIndexPaths:[NSArray arrayWithObject:indexPath] withRowAnimation:UITableViewRowAnimationFade];
//            [tableView insertRowsAtIndexPaths:[NSArray arrayWithObject:newIndexPath] withRowAnimation:UITableViewRowAnimationFade];
//            break;
//    }
//}
//
//
//- (void)controller:(NSFetchedResultsController *)controller didChangeSection:(id <NSFetchedResultsSectionInfo>)sectionInfo atIndex:(NSUInteger)sectionIndex forChangeType:(NSFetchedResultsChangeType)type {
//    
//    switch(type) {
//            
//        case NSFetchedResultsChangeInsert:
//            [self.tableView insertSections:[NSIndexSet indexSetWithIndex:sectionIndex] withRowAnimation:UITableViewRowAnimationFade];
//            break;
//            
//        case NSFetchedResultsChangeDelete:
//            [self.tableView deleteSections:[NSIndexSet indexSetWithIndex:sectionIndex] withRowAnimation:UITableViewRowAnimationFade];
//            break;
//    }
//}
//
//
//- (void)controllerDidChangeContent:(NSFetchedResultsController *)controller {
//    // The fetch controller has sent all current change notifications, so tell the table view to process all updates.
//    [self.tableView endUpdates];
//}

#pragma mark - AddNewSourceView

- (void)addNewSourceControllerDidFinishAdd:(AddNewSourceController *)controller
{
    [self dismissModalViewControllerAnimated:YES];

    //controller.ideaManagementStatusData;
    [dataController addData:controller.ideaManagementStatusData];
    [imsTableView reloadData]; 
    listDidChange = YES;
}

- (void)addNewSourceControllerDidFinishCancel:(AddNewSourceController *)controller
{
    [self dismissModalViewControllerAnimated:YES];
}

#pragma mark - Actions

- (IBAction)done:(id)sender
{
    [self.delegate flipsideViewControllerDidFinish:self];
}

- (IBAction)addSource:(id)sender 
{
    /*
    [dataController addData:@"New Row Added"];
    [imsTableView reloadData]; 
     */
    
    AddNewSourceController *controller = [[[AddNewSourceController alloc] initWithNibName:@"AddNewSourceController" bundle:nil] autorelease];
    // FlipsideViewController *controller = [[[FlipsideViewController alloc] initWithStyle: UITableViewStylePlain] autorelease];
    
    controller.delegate = self;
    controller.managedObjectContext = self.managedObjectContext;
    
    controller.modalTransitionStyle = UIModalTransitionStyleCoverVertical; //UIModalTransitionStyleFlipHorizontal;
    [self presentModalViewController:controller animated:YES];
}

- (IBAction)autorefreshChange:(id)sender
{
    NSLog(@"Segmented Control CHANGE !!!, status: %d",[autorefreshControl selectedSegmentIndex]);
    applicationSettings.autorefreshType = [NSNumber numberWithInt: [autorefreshControl selectedSegmentIndex]];
}

- (IBAction)diffControlChange:(id)sender
{
    NSLog(@"Segmented Diff Control CHANGE !!!, status: %d",[differenceCalcControl selectedSegmentIndex]);
    applicationSettings.diffMode = [NSNumber numberWithInt: [differenceCalcControl selectedSegmentIndex]];
}

@end
