//
//  HistoryDataController.m
//  Gi2MO Monitor
//
//  Created by cyanide on 2/26/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "HistoryDataController.h"
#import "IMS.h"
#import "SourceHistory.h"

@implementation HistoryDataController

@synthesize list;
@synthesize context;

- (unsigned) countOfList
{
    return [list count];
}

- (id)objectInListAtIndex:(unsigned)theIndex 
{
    return [list objectAtIndex:theIndex];
}

- (void)removeDataAtIndex:(unsigned)theIndex
{
    //remove data from core data storge
    SourceHistory *managedObjectOfSourceHistory = [list objectAtIndex:theIndex];
    [context deleteObject:managedObjectOfSourceHistory];
    
    NSError *error;
    if (![context save:&error]) {   //attempt to commit changes
        NSLog(@"Whoops, couldn't save: %@", [error localizedDescription]);
    }
    else //if no error then remove object from the list
        [list removeObjectAtIndex:theIndex]; 
}

- (void)addSourceHistory: (NSString*) title withUrl: (NSString*) url
{
    //save data to core data storage
    SourceHistory *managedObjectOfSourceHistory = [NSEntityDescription
                               insertNewObjectForEntityForName:@"SourceHistory" 
                               inManagedObjectContext:context];
    
    managedObjectOfSourceHistory.title = title; //@"GSI Ideas666";
    managedObjectOfSourceHistory.url = url; //@"http://gsi.gi2mo.org/";
    
    NSError *error;
    if (![context save:&error]) {
        NSLog(@"Whoops, couldn't save: %@", [error localizedDescription]);
    } else //if no errors then add object to list
        [list addObject:managedObjectOfSourceHistory];
}

//- (void)addData:(NSString*)data;
//{
//    //save data to core data storage
//    IMS *managedObjectOfIMS = [NSEntityDescription
//                               insertNewObjectForEntityForName:@"IMS" 
//                               inManagedObjectContext:context];
//    managedObjectOfIMS.title = data; //@"GSI Ideas666";
//    managedObjectOfIMS.url = @"http://gsi.gi2mo.org/";
//    managedObjectOfIMS.dateAdded = [NSDate date];
//    managedObjectOfIMS.hasIdeaCount = [NSNumber numberWithInt:1];
//    managedObjectOfIMS.hasCommentCount = [NSNumber numberWithInt:2];
//    managedObjectOfIMS.hasContestCount = [NSNumber numberWithInt:3];
//    managedObjectOfIMS.hasReviewCount = [NSNumber numberWithInt:4];
//    
//    NSError *error;
//    if (![context save:&error]) {
//        NSLog(@"Whoops, couldn't save: %@", [error localizedDescription]);
//    } else //if no errors then add object to list
//    [list addObject:managedObjectOfIMS];
//}

// Custom set accessor to ensure the new list is mutable
- (void)setList:(NSMutableArray *)newList 
{
    if (list != newList) 
    {
        [list release];
        list = [newList mutableCopy];
    }
}

- (id)init:(NSManagedObjectContext *)managedObjectContext
{
    if (self = [super init]) 
    {
        //set core data context
        self.context = managedObjectContext;
        //Instantiate list
        NSMutableArray *localList = [[NSMutableArray alloc] init];
        self.list = localList;
        [localList release];
        
        //Add initial Data
        //[self addData:@"Item 1"];
        //[self addData:@"Item 2"];
        
        //fetch data from database
        NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
        NSEntityDescription *entity = [NSEntityDescription 
                                       entityForName:@"SourceHistory" inManagedObjectContext:context];
        [fetchRequest setEntity:entity];
        NSError *error;
        self.list = [[context executeFetchRequest:fetchRequest error:&error] mutableCopy];
        [fetchRequest release];
    }
    return self;
}


- (void)dealloc 
{
    [list release];
    context = nil;
    [super dealloc];
}

@end
