//
//  ImsStatusDataController.m
//  Gi2MO Monitor
//
//  Created by cyanide on 3/2/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "ImsStatusDataController.h"
#import "IMS.h"
#import "Idea.h"
#import "User.h"
#import "IdeaManagementStatus.h"

@implementation ImsStatusDataController

@synthesize list;
@synthesize context;

- (unsigned) countOfList
{
    return [list count];
}

- (id)objectInListAtIndex:(unsigned)theIndex 
{
    IdeaManagementStatus *ideaManagementStatus = [[IdeaManagementStatus alloc] init];
    
    //get IMS data from the list
    IMS *managedObjectOfIMS = [list objectAtIndex:theIndex];
   // Idea *managedObjectOfIdea;

    ideaManagementStatus.title = managedObjectOfIMS.title; //@"GSI Ideas666";
    ideaManagementStatus.imsURI = managedObjectOfIMS.url; //@"http://gsi.gi2mo.org/";

    ideaManagementStatus.hasIdeaCount = [NSString stringWithFormat:@"%d", managedObjectOfIMS.hasIdeaCount];
    ideaManagementStatus.hasCommentCount = [NSString stringWithFormat:@"%d", managedObjectOfIMS.hasCommentCount];
    ideaManagementStatus.hasContestCount = [NSString stringWithFormat:@"%d", managedObjectOfIMS.hasContestCount];
    ideaManagementStatus.hasReviewCount = [NSString stringWithFormat:@"%d", managedObjectOfIMS.hasReviewCount];
    
    ideaManagementStatus.ideaTitle = managedObjectOfIMS.hasIdea.title;
    ideaManagementStatus.ideaAuthor = managedObjectOfIMS.hasIdea.hasCreator.accountName;
    NSLog(@"Fetched IMS \"%@\" Status with last idea title: %@ of author: %@", ideaManagementStatus.title, ideaManagementStatus.ideaTitle, ideaManagementStatus.ideaAuthor);
    
    /*
    // fetch last idea data from database
    
    NSPredicate *predicate = [NSPredicate predicateWithFormat:@"hasIMSInstance = %@", managedObjectOfIMS];
    
    NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
    NSEntityDescription *entity = [NSEntityDescription 
                                   entityForName:@"Idea" inManagedObjectContext:context];
    [fetchRequest setEntity:entity];
    [fetchRequest setPredicate:predicate];
    [fetchRequest setRelationshipKeyPathsForPrefetching: [NSArray arrayWithObject:@"hasIdea"]];
    
    NSError *error;
    self.list = [[context executeFetchRequest:fetchRequest error:&error] mutableCopy];

    
    // fetch last comment data from database
    
    // fetch last contest
    */
    return ideaManagementStatus;
}

- (void)removeDataAtIndex:(unsigned)theIndex
{
    //remove data from core data storge
    IMS *imsObject = [list objectAtIndex:theIndex];
    [context deleteObject:imsObject];
    
    NSError *error;
    if (![context save:&error]) {   //attempt to commit changes
        NSLog(@"Whoops, couldn't save: %@", [error localizedDescription]);
    }
    else //if no error then remove object from the list
        [list removeObjectAtIndex:theIndex]; 
}

- (void)addData:(IdeaManagementStatus*)data;
{
    //save data to core data storage
    IMS *managedObjectOfIMS = [NSEntityDescription
                               insertNewObjectForEntityForName:@"IMS" 
                               inManagedObjectContext:context];
    
    managedObjectOfIMS.title = data.title; //@"GSI Ideas666";
    managedObjectOfIMS.url = data.imsURI; //@"http://gsi.gi2mo.org/";
    managedObjectOfIMS.dateAdded = [NSDate date];
    managedObjectOfIMS.hasIdeaCount = [NSNumber numberWithInt:[data.hasIdeaCount intValue]];
    managedObjectOfIMS.hasCommentCount = [NSNumber numberWithInt:[data.hasCommentCount intValue]];
    managedObjectOfIMS.hasContestCount = [NSNumber numberWithInt:[data.hasContestCount intValue]];
    managedObjectOfIMS.hasReviewCount = [NSNumber numberWithInt:[data.hasReviewCount intValue]];
    
    NSError *error;
    if (![context save:&error]) {
        NSLog(@"Whoops, couldn't save: %@", [error localizedDescription]);
    } else //if no errors then add object to list
        [list addObject:managedObjectOfIMS];
}

//- (void)addData:(NSString*)data;
//{
//    //save data to core data storage
//    IMS *managedObjectOfIMS = [NSEntityDescription
//                               insertNewObjectForEntityForName:@"IMS" 
//                               inManagedObjectContext:context];
//    managedObjectOfIMS.title = data; //@"GSI Ideas666";
//    managedObjectOfIMS.url = @"http://gsi.gi2mo.org/";
//    managedObjectOfIMS.dateAdded = [NSDate date];
//    managedObjectOfIMS.hasIdeaCount = [NSNumber numberWithInt:1];
//    managedObjectOfIMS.hasCommentCount = [NSNumber numberWithInt:2];
//    managedObjectOfIMS.hasContestCount = [NSNumber numberWithInt:3];
//    managedObjectOfIMS.hasReviewCount = [NSNumber numberWithInt:4];
//    
//    NSError *error;
//    if (![context save:&error]) {
//        NSLog(@"Whoops, couldn't save: %@", [error localizedDescription]);
//    } else //if no errors then add object to list
//    [list addObject:managedObjectOfIMS];
//}

// Custom set accessor to ensure the new list is mutable
- (void)setList:(NSMutableArray *)newList 
{
    if (list != newList) 
    {
        [list release];
        list = [newList mutableCopy];
    }
}

- (id)init:(NSManagedObjectContext *)managedObjectContext
{
    if (self = [super init]) 
    {
        //set core data context
        self.context = managedObjectContext;
        //Instantiate list
        NSMutableArray *localList = [[NSMutableArray alloc] init];
        self.list = localList;
        [localList release];
        
        //Add initial Data
        //[self addData:@"Item 1"];
        //[self addData:@"Item 2"];
        
        //fetch IMS data from database
        NSFetchRequest *fetchRequest = [[NSFetchRequest alloc] init];
        NSEntityDescription *entity = [NSEntityDescription 
                                       entityForName:@"IMS" inManagedObjectContext:context];
        [fetchRequest setEntity:entity];
        //[fetchRequest setReturnsObjectsAsFaults:NO];
        //[fetchRequest setIncludesPropertyValues:YES];
        //[fetchRequest setRelationshipKeyPathsForPrefetching: [NSArray arrayWithObject:@"hasIdea"]];
        
        NSError *error;
        self.list = [[context executeFetchRequest:fetchRequest error:&error] mutableCopy];
        
        [fetchRequest release];
    }
    return self;
}


- (void)dealloc 
{
    [list release];
    context = nil;
    [super dealloc];
}


@end
