//
//  TestPageController.m
//  Gi2MO Monitor
//
//  Created by cyanide on 2/26/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "ImsStatusPageController.h"
#import "XMLReader.h"
#import "IdeaManagementStatus.h"

#import "IMS.h"
#import "Idea.h"
#import "Contest.h"
#import "Comment.h"
#import "User.h"

#import "Settings.h"

#import "FetchRDFOperation.h"

@implementation ImsStatusPageController

@synthesize	imsName;
@synthesize imsLastUpdated;

@synthesize	ideaNumber;
@synthesize	commentNumber;
@synthesize	contestNumber;
@synthesize	reviewNumber;

@synthesize	lastIdeaDate;
@synthesize	lastIdeaTitle;
@synthesize	lastIdeaAuthor;

@synthesize	lastCommentDate;
@synthesize	lastCommentTitle;
@synthesize	lastCommentAuthor;

@synthesize connectionStatus;

@synthesize	lastContestDate;
@synthesize	lastContestTitle;
@synthesize	lastContestAuthor;
@synthesize refreshAnimatedImage;
@synthesize refreshButton;

//core data
@synthesize managedObjectContext;
//@synthesize fetchedResultsController
@synthesize parentScrollViewController;
@synthesize dataController;
@synthesize applicationSettings;
@synthesize queue;


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (id)initWithPageNumber:(int)page {
    if (self = [super initWithNibName:@"ImsStatusPageController" bundle:nil])    {
        pageNumber = page;
        //setup notification center
        queue = [[NSOperationQueue alloc] init];
        [[NSNotificationCenter defaultCenter] addObserver:self 
                                                 selector:@selector(updateAnswer:) 
                                                     name:[NSString stringWithFormat:@"rdfDownloadFinished forStatusPage: %d", pageNumber]
                                                   object:nil];
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}


#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [self updateStatistics];
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    //pageNumberLabel.text = [NSString stringWithFormat:@"Page %d", pageNumber + 1];
    //self.view.backgroundColor = [TestPageController testPageControllerColorWithIndex:pageNumber];


    if ([parentScrollViewController.applicationSettings.autorefreshType intValue] == 2) //automatically fetch RDF and update display
    {
        //perform fetch only if last update was more than 1 hour ago
        IMS *ims = [dataController objectInListAtIndex: pageNumber];
        
        NSTimeInterval timeInt = [ims.dateAdded timeIntervalSinceNow];
        NSLog(@"Time internval for page: %i is: %f", pageNumber, timeInt); //timeInt < -60 &&
        if (refreshButton.hidden == NO) { //check if update has been already fired
            NSLog(@"update event fired!");
            [self resyncStatistocsAction: self];
        }
    }
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Flipside View

- (void)flipsideViewControllerDidFinish:(FlipsideViewController *)controller
{
    [self dismissModalViewControllerAnimated:YES];
}

- (IBAction)showInfo:(id)sender
{    
    /*
    FlipsideViewController *controller = [[[FlipsideViewController alloc] initWithNibName:@"FlipsideViewController" bundle:nil] autorelease];
    // FlipsideViewController *controller = [[[FlipsideViewController alloc] initWithStyle: UITableViewStylePlain] autorelease];
    
    controller.delegate = self;
    controller.managedObjectContext = self.managedObjectContext;
    
    controller.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
    [self presentModalViewController:controller animated:YES];
     */
    parentScrollViewController.showInfo;
}


- (IBAction)resyncStatistocsAction:(id)sender
{    
    
    //start button animation
    int numberOfFrames = 8;
    NSMutableArray *imagesArray = [NSMutableArray arrayWithCapacity:numberOfFrames];
    for (int i=1; numberOfFrames > i; ++i)
    {
        //[imagesArray addObject:[UIImage imageNamed: [NSString stringWithFormat:@"refresh_icon_animated.gif"]]];
//        NSLog([NSString stringWithFormat:@"refresh_icon_animated%d.png", i]);
        [imagesArray addObject:[UIImage imageNamed: [NSString stringWithFormat:@"refresh_icon_animated%d.png", i]]]; //
    }
    
    
    //UIImageView *anImageView = [[[UIImageView alloc] initWithFrame:CGRectMake(40,100,250,188)] autorelease];
    //[self.view addSubview:anImageView];
    refreshAnimatedImage.animationImages = imagesArray; 
    refreshAnimatedImage.animationDuration = 0.8;
    refreshAnimatedImage.hidden = NO;
    refreshButton.hidden = YES;
    [refreshAnimatedImage startAnimating];
    //[refreshButton setImage:btnImage forState:UIControlStateNormal];
    
    //test bcg thread running
    // Create our operation and send it to the service
    IMS *ims = [dataController objectInListAtIndex: pageNumber];
    
    if (ims == nil) return;
    
    FetchRDFOperation *operation = [[FetchRDFOperation alloc]init];
    operation.url = ims.url;
    operation.pageNumber = pageNumber;
    
    [[self queue] addOperation:operation];
    // memory management
    [operation release];
    //[ims release];
    
    imsLastUpdated.text = @"Updating ..."; 
    ///end of test
    
    //fetch RDF
    //[self fetchRDFStatistics];
    //change outlets
    //[self updateStatistics];
    
    //refresh view
    //[super viewDidLoad];
    //[refreshAnimatedImage stopAnimating];
    //refreshAnimatedImage.hidden = YES;
    //refreshButton.hidden = NO;
    
}


//custom methods

//update the view with statistics from core data object
- (void) updateStatistics
{

    IMS *ims = [dataController objectInListAtIndex: pageNumber];

    if (ims == nil) return; //if the object does not exist return nil
    
    imsName.text = ims.title;
    
    ideaNumber.text = [NSString stringWithFormat:@"%@", ims.hasIdeaCount];
    commentNumber.text = [NSString stringWithFormat:@"%@", ims.hasCommentCount];
    contestNumber.text = [NSString stringWithFormat:@"%@", ims.hasContestCount];
    reviewNumber.text = [NSString stringWithFormat:@"%@", ims.hasReviewCount];
    
    //set latest content summary
    lastIdeaTitle.text = ims.hasIdea.title;
    lastIdeaDate.text = ims.hasIdea.created;
    lastIdeaAuthor.text = ims.hasIdea.hasCreator.accountName;
    
    lastCommentTitle.text = ims.hasComment.content;
    lastCommentDate.text = ims.hasComment.created;
    lastCommentAuthor.text = ims.hasComment.hasCreator.accountName;
    
    lastContestTitle.text = ims.hasContest.title;
    lastContestDate.text =  ims.hasContest.created;
    lastContestAuthor.text = ims.hasContest.hasCreator.accountName;
    
    NSDateFormatter* dateFormatter = [[[NSDateFormatter alloc] init] autorelease];
    dateFormatter.dateFormat = @"yyyy-MM-dd HH:mm";     
    
    imsLastUpdated.text = [NSString stringWithFormat:@"Updated %@", [dateFormatter stringFromDate: ims.dateAdded]];
    imsLastUpdated.hidden = NO;
}

//fetch the RDF and update core data objects
- (void) fetchRDFStatistics
{
    //ideaNumber.text = [NSString stringWithFormat: @"keks"];
    IMS *ims = [dataController objectInListAtIndex: pageNumber];
    
    //testing
    //XMLReader *anInst = [[[XMLReader alloc] init] autorelease];
    
    //parse XML
    /*        
     NSURL *url = [[NSURL alloc] initWithString:@"http://192.168.1.33/~cyanide/gi2mo_ideas.rdf"];
     
     //NSURL *url = [[NSURL alloc] initWithString:@"http://ideas.gi2mo.org/gi2mo_ideas.rdf"];
     //NSURL *url = [[NSURL alloc] initWithString:@"http://192.168.1.33/~cyanide/Books2.xml"];
     NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithContentsOfURL:url]; */
    
    //alternative with timeout
    
    NSString *u = [NSString stringWithFormat:@"http://ideas.gi2mo.org/gi2mo_ideas666.rdf"];
    
    //NSString *u = ims.url; //[NSString stringWithFormat:@"%@",ims.url];
    
    //    NSString *u = [NSString stringWithFormat:@"http://192.168.1.33/~cyanide/gi2mo_ideas666.rdf"];
    //    NSString *u = [NSString stringWithFormat:@"http://192.168.1.33/~cyanide/gi2mo_ideas.rdf"];
    NSURLRequest* chRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:u] cachePolicy: NSURLRequestReloadIgnoringCacheData timeoutInterval:1000];
    NSError* theError;
    NSData* response = [NSURLConnection sendSynchronousRequest:chRequest returningResponse:nil error:&theError]; 
    
    NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithData:response];
    
    //enable namespace parsing
    [xmlParser setShouldProcessNamespaces:YES];
    
    //Initialize the delegate.
    XMLReader *parser = [[XMLReader alloc] initXMLReader];
    
    //Set delegate
    [xmlParser setDelegate:parser];
    
    //Start parsing the XML file.
    BOOL success = [xmlParser parse];
    
    if(success && response!= nil)
    {
        NSLog(@"No Errors");
        [dataController updateData: parser.ideaManagementStatus AtIndex: pageNumber];
        //set core data values
        /*
        ims.title = parser.ideaManagementStatus.title;
        
        //ims.url = parser.ideaManagementStatus.imsURI; //@"http://gsi.gi2mo.org/";
        ims.dateAdded = [NSDate date];
        ims.hasIdeaCount = [NSNumber numberWithInt:[parser.ideaManagementStatus.hasIdeaCount intValue]];
        ims.hasCommentCount = [NSNumber numberWithInt:[parser.ideaManagementStatus.hasCommentCount intValue]];
        ims.hasContestCount = [NSNumber numberWithInt:[parser.ideaManagementStatus.hasContestCount intValue]];
        ims.hasReviewCount = [NSNumber numberWithInt:[parser.ideaManagementStatus.hasReviewCount intValue]];

        //set Idea
        ims.hasIdea.hasCreator.accountName = parser.ideaManagementStatus.ideaAuthor;  
        ims.hasIdea.created = parser.ideaManagementStatus.ideaDate;
        ims.hasIdea.title = parser.ideaManagementStatus.ideaTitle;
        
        //set Comment
        
        ims.hasComment.hasCreator.accountName = parser.ideaManagementStatus.commentAuthor; 
        ims.hasComment.created = parser.ideaManagementStatus.commentDate;
        ims.hasComment.content = parser.ideaManagementStatus.commentText;

        
        //set Contest        
        ims.hasContest.hasCreator.accountName = parser.ideaManagementStatus.contestAuthor;        
        ims.hasContest.created = parser.ideaManagementStatus.contestDate;
        ims.hasContest.title = parser.ideaManagementStatus.contestTitle;
         */

    }
    else
    {
        
        NSLog(@"Error Error Error!!!");
        /*
        imsName.text = @"CONNECTION ERROR";
        imsName.textAlignment = UITextAlignmentCenter;
        imsName.textColor = [UIColor colorWithRed:255.0 green:0.0 blue:0.0 alpha:1.0];
        imsName.font = [UIFont systemFontOfSize: 15];
        //        imsName.font = [UIFont boldSystemFontOfSize:0];
        ideaNumber.text = @"";
        commentNumber.text = @"";
        contestNumber.text = @"";
        reviewNumber.text = @"";
        
        //set latest content summary
        lastIdeaTitle.text = @"";
        lastIdeaDate.text = @"(   )";
        lastIdeaAuthor.text = @"author";
        
        lastCommentTitle.text = @"";
        lastCommentDate.text = @"(   )";
        lastCommentAuthor.text = @"author";
        
        lastContestTitle.text = @"";
        lastContestDate.text = @"(   )";
        lastContestAuthor.text = @"author"; */
    }
}

- (void) updateAnswer:(NSNotification *)notification{
    // Make sure the updates get performed on the main thread
    if (NO==[NSThread isMainThread]){
        [self performSelectorOnMainThread:@selector(updateAnswer:) withObject:notification waitUntilDone:NO];
        return;
    }
    //[[self activityIndicator] stopAnimating];

    IdeaManagementStatus *imsStatus = [[notification userInfo] objectForKey:[NSString stringWithFormat:@"rdfDownloadFinished forStatusPage: %d", pageNumber]];
    //[[self answerLabel] setText:[NSString stringWithFormat:@"%d",[newNumber intValue]]];
    //NSLog(@"test message _ some thread just delivered results !: %@",imsStatus);
    if (imsStatus.transferSuccess == YES) {
        [dataController updateData: imsStatus AtIndex: pageNumber];
        [self updateStatistics];
        
        NSDateFormatter* dateFormatter = [[[NSDateFormatter alloc] init] autorelease];
        dateFormatter.dateFormat = @"yyyy-MM-dd HH:mm";     
        
        imsLastUpdated.text = [NSString stringWithFormat:@"Updated %@", [dateFormatter stringFromDate: [NSDate date]]];
        imsLastUpdated.hidden = NO;
        connectionStatus.hidden = YES;
    }
    else 
    {
        connectionStatus.hidden = NO;
        IMS *ims = [dataController objectInListAtIndex: pageNumber];
        
        NSDateFormatter* dateFormatter = [[[NSDateFormatter alloc] init] autorelease];
        dateFormatter.dateFormat = @"yyyy-MM-dd HH:mm";     
        
        imsLastUpdated.text = [NSString stringWithFormat:@"Updated %@", [dateFormatter stringFromDate: ims.dateAdded]];
        
        //[ims release];
        [dateFormatter release];
    }

    // make refresh button active again
    [refreshAnimatedImage stopAnimating];
    refreshAnimatedImage.hidden = YES;
    refreshButton.hidden = NO;
}

#pragma mark -
#pragma mark Memory management

- (void)dealloc {
    //    [fetchedResultsController release];
    [managedObjectContext release];
    [queue release];
    //    [addingManagedObjectContext release];
    [super dealloc];
}

@end
