//
//  MainViewController.m
//  Gi2MO Monitor
//
//  Created by cyanide on 2/18/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "MainViewController.h"
#import "XMLReader.h"
#import "IdeaManagementStatus.h"
#import "ScrollViewController.h"

@implementation MainViewController

@synthesize parentV;

@synthesize	imsName;

@synthesize	ideaNumber;
@synthesize	commentNumber;
@synthesize	contestNumber;
@synthesize	reviewNumber;

@synthesize	lastIdeaDate;
@synthesize	lastIdeaTitle;
@synthesize	lastIdeaAuthor;

@synthesize	lastCommentDate;
@synthesize	lastCommentTitle;
@synthesize	lastCommentAuthor;

@synthesize	lastContestDate;
@synthesize	lastContestTitle;
@synthesize	lastContestAuthor;

//core data
@synthesize managedObjectContext;
//@synthesize fetchedResultsController

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle

- (void)viewDidLoad
{
    [self updateStatistics];
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (void)viewWillAppear:(BOOL)animated
{
    [super viewWillAppear:animated];
}

- (void)viewDidAppear:(BOOL)animated
{
    [super viewDidAppear:animated];
}

- (void)viewWillDisappear:(BOOL)animated
{
	[super viewWillDisappear:animated];
}

- (void)viewDidDisappear:(BOOL)animated
{
	[super viewDidDisappear:animated];
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation != UIInterfaceOrientationPortraitUpsideDown);
}

#pragma mark - Flipside View

- (void)flipsideViewControllerDidFinish:(FlipsideViewController *)controller
{
    [self dismissModalViewControllerAnimated:YES];
}

- (IBAction)showInfo:(id)sender
{    
    
    parentV.showInfo;
//    FlipsideViewController *controller = [[[FlipsideViewController alloc] initWithNibName:@"FlipsideViewController" bundle:nil] autorelease];
//    // FlipsideViewController *controller = [[[FlipsideViewController alloc] initWithStyle: UITableViewStylePlain] autorelease];
//
//    controller.delegate = self;
//    controller.managedObjectContext = self.managedObjectContext;
//    
//    controller.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
//    [self presentModalViewController:controller animated:YES];
}

//custom methods
- (void) updateStatistics
{
    ideaNumber.text = [NSString stringWithFormat: @"keks"];
    
    //testing
    //XMLReader *anInst = [[[XMLReader alloc] init] autorelease];

    //parse XML
/*        
    NSURL *url = [[NSURL alloc] initWithString:@"http://192.168.1.33/~cyanide/gi2mo_ideas.rdf"];

    //NSURL *url = [[NSURL alloc] initWithString:@"http://ideas.gi2mo.org/gi2mo_ideas.rdf"];
    //NSURL *url = [[NSURL alloc] initWithString:@"http://192.168.1.33/~cyanide/Books2.xml"];
    NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithContentsOfURL:url]; */
    
    //alternative with timeout
    
    NSString *u = [NSString stringWithFormat:@"http://ideas.gi2mo.org/gi2mo_ideas.rdf"];
//    NSString *u = [NSString stringWithFormat:@"http://192.168.1.33/~cyanide/gi2mo_ideas666.rdf"];
//    NSString *u = [NSString stringWithFormat:@"http://192.168.1.33/~cyanide/gi2mo_ideas.rdf"];
    NSURLRequest* chRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:u] cachePolicy: NSURLRequestReloadIgnoringCacheData timeoutInterval:10];
    NSError* theError;
    NSData* response = [NSURLConnection sendSynchronousRequest:chRequest returningResponse:nil error:&theError]; 
    
    NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithData:response];
    
    //enable namespace parsing
    [xmlParser setShouldProcessNamespaces:YES];
    
    //Initialize the delegate.
    XMLReader *parser = [[XMLReader alloc] initXMLReader];

    //Set delegate
    [xmlParser setDelegate:parser];
    
    //Start parsing the XML file.
    BOOL success = [xmlParser parse];
    
    if(success && response!= nil)
    {
        NSLog(@"No Errors");
        imsName.text = parser.ideaManagementStatus.title;
        
        ideaNumber.text = parser.ideaManagementStatus.hasIdeaCount;
        commentNumber.text = parser.ideaManagementStatus.hasCommentCount;
        contestNumber.text = parser.ideaManagementStatus.hasContestCount;
        reviewNumber.text = parser.ideaManagementStatus.hasReviewCount;
        
        //set latest content summary
        lastIdeaTitle.text = parser.ideaManagementStatus.ideaTitle;
        lastIdeaDate.text = [NSString stringWithFormat:@"(%@)", parser.ideaManagementStatus.ideaDate];
        lastIdeaAuthor.text = parser.ideaManagementStatus.ideaAuthor;
        
        lastCommentTitle.text = parser.ideaManagementStatus.commentText;
        lastCommentDate.text = [NSString stringWithFormat:@"(%@)", parser.ideaManagementStatus.commentDate];
        lastCommentAuthor.text = parser.ideaManagementStatus.commentAuthor;
        
        lastContestTitle.text = parser.ideaManagementStatus.contestTitle;
        lastContestDate.text = [NSString stringWithFormat:@"(%@)", parser.ideaManagementStatus.contestDate];
        lastContestAuthor.text = parser.ideaManagementStatus.contestAuthor;
    }
    else
    {
        NSLog(@"Error Error Error!!!");
        imsName.text = @"CONNECTION ERROR";
        imsName.textAlignment = UITextAlignmentCenter;
        imsName.textColor = [UIColor colorWithRed:255.0 green:0.0 blue:0.0 alpha:1.0];
        imsName.font = [UIFont systemFontOfSize: 15];
//        imsName.font = [UIFont boldSystemFontOfSize:0];
        ideaNumber.text = @"";
        commentNumber.text = @"";
        contestNumber.text = @"";
        reviewNumber.text = @"";
        
        //set latest content summary
        lastIdeaTitle.text = @"";
        lastIdeaDate.text = @"(   )";
        lastIdeaAuthor.text = @"author";
        
        lastCommentTitle.text = @"";
        lastCommentDate.text = @"(   )";
        lastCommentAuthor.text = @"author";
        
        lastContestTitle.text = @"";
        lastContestDate.text = @"(   )";
        lastContestAuthor.text = @"author";
    }
}

#pragma mark -
#pragma mark Memory management

- (void)dealloc {
//    [fetchedResultsController release];
    [managedObjectContext release];
//    [addingManagedObjectContext release];
    [super dealloc];
}

@end
