//
//  StatusViewController.h
//  Gi2MO Monitor
//
//  Created by cyanide on 2/26/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "FlipsideViewController.h"
#import "DataController.h"
#import "Settings.h"

#define kNumberOfPages 1

@interface ScrollViewController : UIViewController <UIScrollViewDelegate, FlipsideViewControllerDelegate> {

    //pagination
    IBOutlet UIScrollView *scrollView;
    IBOutlet UIPageControl *pageControl;
    NSMutableArray *viewControllers;
    BOOL pageControlUsed;
    int numberOfPages;
    NSNumber *currentDiffMode;
    
    //----------core data--------
    //    NSFetchedResultsController *fetchedResultsController;
    NSManagedObjectContext *managedObjectContext;
    DataController *dataController;
    Settings *applicationSettings;
    
}

// core data
@property (nonatomic, retain) NSManagedObjectContext *managedObjectContext;
@property (nonatomic, retain) DataController *dataController;
@property (nonatomic, retain) Settings *applicationSettings;

//pagination
@property (nonatomic, retain) UIScrollView *scrollView;
@property (nonatomic, retain) UIPageControl *pageControl;
@property (nonatomic, retain) NSMutableArray *viewControllers;

- (void)loadScrollViewWithPage:(int)page;
- (IBAction)changePage:(id)sender;
- (void)showInfo;
- (IdeaManagementStatus *) fetchRDFStatistics :(NSString *) url;

@end
