//
//  XMLReader.m
//  Gi2MO Monitor
//
//  Created by cyanide on 2/19/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "XMLReader.h"
#import "IdeaManagementStatus.h"

@implementation XMLReader

@synthesize currentClassName;
@synthesize currentObjectURI;
@synthesize ideaManagementStatus;
@synthesize currentClassProperties;
@synthesize allUserNames;


- (XMLReader *) initXMLReader {
    
    [super init];
    ideaManagementStatus = [[IdeaManagementStatus alloc] init];
    allUserNames = [[NSMutableDictionary alloc] init];
    //appDelegate = (XMLAppDelegate *)[[UIApplication sharedApplication] delegate];
    
    return self;
}


//get current element name
- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName
    attributes:(NSDictionary *)attributeDict {
    
    /*
    if([elementName isEqualToString:@"gi2mo:IdeaManagementSystem"]) {
        ideaManagementStatus = [[IdeaManagementStatus alloc] init];
        ideaManagementStatus.title= @"dupa Romana";
    }
    else if([elementName isEqualToString:@"IdeaManagementSystem"]) {
        
        //Initialize the book.
        currentClassName = elementName; //@"IdeaManagementSystem";
        //ideaManagementStatus = [[IdeaManagementStatus alloc] init];
        
        //Extract the attribute here.
        //ideaManagementStatus.imsURI = [attributeDict objectForKey:@"rdf:about"];
        currentObjectURI = [attributeDict objectForKey:@"rdf:about"];
    }
    else */ 
        
    if([elementName isEqualToString:@"Idea"] || [elementName isEqualToString:@"Comment"] || [elementName isEqualToString:@"IdeaContest"] || [elementName isEqualToString:@"User"] || [elementName isEqualToString:@"Description"] || [elementName isEqualToString:@"IdeaManagementSystem"]) {
        currentClassName = elementName;
        currentObjectURI = [attributeDict objectForKey:@"rdf:about"];
        [currentClassProperties release];
        currentClassProperties = [[NSMutableDictionary alloc] init];
        //[currentClassProperties
    }
    else if ([elementName isEqualToString:@"hasCreator"])
    {
        [currentClassProperties setObject:[attributeDict objectForKey:@"rdf:resource"] forKey:elementName];
        //[dict setObject:[NSNumber numberWithInt:42] forKey:@"age"];
        
//        if ([currentClassName isEqualToString:@"Idea"]) ideaManagementStatus.ideaAuthor = [attributeDict objectForKey:@"rdf:resource"];
//        if ([currentClassName isEqualToString:@"Comment"]) ideaManagementStatus.commentAuthor = [attributeDict objectForKey:@"rdf:resource"];
//        if ([currentClassName isEqualToString:@"IdeaContest"]) ideaManagementStatus.contestAuthor = [attributeDict objectForKey:@"rdf:resource"];
    }
    else if([currentClassName isEqualToString:@"Description"] && [elementName isEqualToString:@"type"]) { //in case of RDF/XMl (not RDF abbrev, the class name is encoded in rdf:type)
        currentClassName = [attributeDict objectForKey:@"rdf:resource"];
        if ([currentClassName rangeOfString:@"#"].location != NSNotFound)
            currentClassName = [currentClassName substringFromIndex: [currentClassName rangeOfString:@"#"].location+1 ];
        //NSLog(@"the class name in RDF/XML format: %@",currentClassName);
    }
    
    //NSLog(@"Processing Element: %@", elementName);
}

//get current element value
- (void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string {
    currentElementValue = [[NSMutableString alloc] initWithString:string];
/*    
    if(!currentElementValue)
        currentElementValue = [[NSMutableString alloc] initWithString:string];
    else
        [currentElementValue appendString:string]; */
    
    //NSLog(@"Processing Value:%@ vs processed value:%@", string,currentElementValue);
    
}

//get current element ending tag
- (void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName
  namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName {
        
    //There is nothing to do if we encounter the Books element here.
    //If we encounter the Book element howevere, we want to add the book object to the array
    // and release the object.
    
    /*
    if([elementName isEqualToString:currentClassName]) {
        currentClassName = nil;
    } */
        
    if ([elementName isEqualToString:@"Idea"] || [elementName isEqualToString:@"Comment"] || [elementName isEqualToString:@"IdeaContest"] || [elementName isEqualToString:@"User"] || [elementName isEqualToString:@"IdeaManagementSystem"] || [elementName isEqualToString:@"Description"] ) //if one of the classes ends, save all its properties
    {       
         /*
        for(id propertyName in currentClassProperties) {
            NSString *propertyValue = [currentClassProperties objectForKey:propertyName];
            NSLog(@"Settings property %@ with value %@",propertyName, propertyValue);
        } */
        //NSLog(@"Gunna set some props for class: %@", currentClassName);
        if ([currentClassName isEqualToString:@"IdeaManagementSystem"]) { //Idea Management System class
            //current stats

            if ([currentClassProperties objectForKey:@"title"] != NULL) ideaManagementStatus.title = [currentClassProperties objectForKey:@"title"];
            if (currentObjectURI != NULL) ideaManagementStatus.imsURI = currentObjectURI;
            
            if([currentClassProperties objectForKey:@"ideaCount"] != NULL) ideaManagementStatus.hasIdeaCount = [currentClassProperties objectForKey:@"ideaCount"];
            if([currentClassProperties objectForKey:@"commentCount"] != NULL) ideaManagementStatus.hasCommentCount = [currentClassProperties objectForKey:@"commentCount"];
            if([currentClassProperties objectForKey:@"contestCount"] != NULL) ideaManagementStatus.hasContestCount = [currentClassProperties objectForKey:@"contestCount"];
            if([currentClassProperties objectForKey:@"reviewCount"] != NULL) ideaManagementStatus.hasReviewCount = [currentClassProperties objectForKey:@"reviewCount"];
            
            //last day stats
            if([currentClassProperties objectForKey:@"ideaCountLastDay"]) ideaManagementStatus.hasIdeaCountLastDay = [currentClassProperties objectForKey:@"ideaCountLastDay"];
            if([currentClassProperties objectForKey:@"commentCountLastDay"]) ideaManagementStatus.hasCommentCountLastDay = [currentClassProperties objectForKey:@"commentCountLastDay"];
            if([currentClassProperties objectForKey:@"contestCountLastDay"]) ideaManagementStatus.hasContestCountLastDay = [currentClassProperties objectForKey:@"contestCountLastDay"];
            if([currentClassProperties objectForKey:@"reviewCountLastDay"]) ideaManagementStatus.hasReviewCountLastDay = [currentClassProperties objectForKey:@"reviewCountLastDay"];
            
            //last week stats
            if([currentClassProperties objectForKey:@"ideaCountLastWeek"]) ideaManagementStatus.hasIdeaCountLastWeek = [currentClassProperties objectForKey:@"ideaCountLastWeek"];
            if([currentClassProperties objectForKey:@"commentCountLastWeek"]) ideaManagementStatus.hasCommentCountLastWeek = [currentClassProperties objectForKey:@"commentCountLastWeek"];
            if([currentClassProperties objectForKey:@"contestCountLastWeek"]) ideaManagementStatus.hasContestCountLastWeek = [currentClassProperties objectForKey:@"contestCountLastWeek"];
            if([currentClassProperties objectForKey:@"reviewCountLastWeek"]) ideaManagementStatus.hasReviewCountLastWeek = [currentClassProperties objectForKey:@"reviewCountLastWeek"];
            
            //last month stats
            if([currentClassProperties objectForKey:@"ideaCountLastMonth"]) ideaManagementStatus.hasIdeaCountLastMonth = [currentClassProperties objectForKey:@"ideaCountLastMonth"];
            if([currentClassProperties objectForKey:@"commentCountLastMonth"]) ideaManagementStatus.hasCommentCountLastMonth = [currentClassProperties objectForKey:@"commentCountLastMonth"];
            if([currentClassProperties objectForKey:@"contestCountLastMonth"]) ideaManagementStatus.hasContestCountLastMonth = [currentClassProperties objectForKey:@"contestCountLastMonth"];
            if([currentClassProperties objectForKey:@"reviewCountLastMonth"]) ideaManagementStatus.hasReviewCountLastMonth = [currentClassProperties objectForKey:@"reviewCountLastMonth"];
            
            //last year stats
            if([currentClassProperties objectForKey:@"ideaCountLastYear"]) ideaManagementStatus.hasIdeaCountLastYear = [currentClassProperties objectForKey:@"ideaCountLastYear"];
            if([currentClassProperties objectForKey:@"commentCountLastYear"]) ideaManagementStatus.hasCommentCountLastYear = [currentClassProperties objectForKey:@"commentCountLastYear"];
            if([currentClassProperties objectForKey:@"contestCountLastYear"]) ideaManagementStatus.hasContestCountLastYear = [currentClassProperties objectForKey:@"contestCountLastYear"];
            if([currentClassProperties objectForKey:@"reviewCountLastYear"]) ideaManagementStatus.hasReviewCountLastYear = [currentClassProperties objectForKey:@"reviewCountLastYear"];
            
            //NSLog(@"Idea count is: %@", ideaManagementStatus.hasIdeaCount);
        }
        else if ([currentClassName isEqualToString:@"Idea"]) { //Idea Management System class

            if([currentClassProperties objectForKey:@"created"] !=NULL) 
                ideaManagementStatus.ideaDate = [currentClassProperties objectForKey:@"created"];
            if([currentClassProperties objectForKey:@"title"] !=NULL) 
                ideaManagementStatus.ideaTitle = [currentClassProperties objectForKey:@"title"];
            if([currentClassProperties objectForKey:@"hasCreator"] !=NULL) {
                ideaManagementStatus.ideaAuthor = [currentClassProperties objectForKey:@"hasCreator"];
                if ([allUserNames objectForKey:ideaManagementStatus.ideaAuthor]!=NULL) //check if the username was already dereferenced
                    ideaManagementStatus.ideaAuthor = [allUserNames objectForKey:ideaManagementStatus.ideaAuthor];
            }
        }
        else if ([currentClassName isEqualToString:@"IdeaContest"]) { //Idea Management System class
            
            if([currentClassProperties objectForKey:@"created"] !=NULL) 
                ideaManagementStatus.contestDate = [currentClassProperties objectForKey:@"created"];
            if([currentClassProperties objectForKey:@"title"]) 
                ideaManagementStatus.contestTitle = [currentClassProperties objectForKey:@"title"];
            if([currentClassProperties objectForKey:@"hasCreator"] !=NULL) {
                ideaManagementStatus.contestAuthor = [currentClassProperties objectForKey:@"hasCreator"];
                if ([allUserNames objectForKey:ideaManagementStatus.contestAuthor]!=NULL) //check if the username was already dereferenced
                    ideaManagementStatus.contestAuthor = [allUserNames objectForKey:ideaManagementStatus.contestAuthor];
            }
        }
        else if ([currentClassName isEqualToString:@"Comment"]) { //Idea Management System class
            
            if([currentClassProperties objectForKey:@"created"] !=NULL) 
                ideaManagementStatus.commentDate = [currentClassProperties objectForKey:@"created"];
            if([currentClassProperties objectForKey:@"content"] !=NULL) 
                ideaManagementStatus.commentText = [currentClassProperties objectForKey:@"content"];
            if([currentClassProperties objectForKey:@"hasCreator"] !=NULL) {
                ideaManagementStatus.commentAuthor = [currentClassProperties objectForKey:@"hasCreator"];
                if ([allUserNames objectForKey:ideaManagementStatus.commentAuthor]!=NULL) //check if the username was already dereferenced
                    ideaManagementStatus.commentAuthor = [allUserNames objectForKey:ideaManagementStatus.commentAuthor];
            }
        }
        else if ([currentClassName isEqualToString:@"User"]) { //Idea Management System class

            if(([currentClassProperties objectForKey:@"accountName"] !=NULL) && [currentObjectURI isEqualToString:ideaManagementStatus.ideaAuthor])
                ideaManagementStatus.ideaAuthor = [currentClassProperties objectForKey:@"accountName"];
            if(([currentClassProperties objectForKey:@"accountName"] !=NULL) && [currentObjectURI isEqualToString:ideaManagementStatus.commentAuthor])
                ideaManagementStatus.commentAuthor = [currentClassProperties objectForKey:@"accountName"];
            if(([currentClassProperties objectForKey:@"accountName"] !=NULL) && [currentObjectURI isEqualToString:ideaManagementStatus.contestAuthor])
                ideaManagementStatus.contestAuthor = [currentClassProperties objectForKey:@"accountName"];
            if ([currentClassProperties objectForKey:@"accountName"] !=NULL) //set the author account name for future reference in case gi2mo:User is before Idea,Comment or Contest classes in the XML
                [allUserNames setObject:[currentClassProperties objectForKey:@"accountName"] forKey:currentObjectURI];
        }
        currentClassName = nil;
    } else if (currentClassName!= nil) { //if no class ending was detected and there is a class name set than assuming its a class property ending
         if ([currentClassProperties objectForKey:elementName] == NULL) //only set if the property hasnt been defined before (as in its not a object property)
              [currentClassProperties setObject:currentElementValue forKey:elementName];
    }
    
    [currentElementValue release];
    currentElementValue = nil;
}

- (void) dealloc {
    
    [ideaManagementStatus release];
    [currentClassName release];
    [allUserNames release];
    [currentClassProperties release];
    
    [super dealloc];
}

@end
