//
//  MetroStyleColorSet.m
//  Gi2MO Monitor
//
//  Created by cyanide on 3/10/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "MetroStyleColorSet.h"

@implementation MetroStyleColorSet

@synthesize mainColor;
@synthesize valueBackgroundColor;
@synthesize valueFontColor;


- (id)initWithColor:(UIColor *) mColor valueBackgroundColor:(UIColor *) bcgColor fontColor:(UIColor *) fntColor
{
    if (self = [super init]) 
    {
        self.mainColor = mColor;
        self.valueBackgroundColor = bcgColor;
        self.valueFontColor = fntColor;
    }
    return self;
}

- (id)initWithColorSetNumber: (int) colorSetNumber {
    if (self = [super init]) 
    {
        [self setColorSet: colorSetNumber];
    }
    return self;    
}

- (int) getColorSetsCount 
{
    return 6;
}

/*
 * Sets the color valiables based on color set number
 * Current color sets:
 * 0 - blue
 * 1 - green
 * 2 - red
 * 3 - purple
 * 4 - orange
 */
- (void) setColorSet: (int) colorSetNumber {
    
    switch (colorSetNumber)
    
    {
        case 0:
            //blue theme  
            self.mainColor = [UIColor colorWithRed:63/255.0f green:169/255.0f blue:245/255.0f alpha:1];
            self.valueBackgroundColor = [UIColor colorWithRed:178/255.0f green:221/255.0f blue:251/255.0f alpha:1];
            self.valueFontColor = [UIColor colorWithRed:47/255.0f green:127/255.0f blue:184/255.0f alpha:1];
            break;
        case 1:
            //green theme
            self.mainColor = [UIColor colorWithRed:122/255.0f green:201/255.0f blue:67/255.0f alpha:1];
            self.valueBackgroundColor = [UIColor colorWithRed:202/255.0f green:233/255.0f blue:180/255.0f alpha:1];
            self.valueFontColor = [UIColor colorWithRed:92/255.0f green:151/255.0f blue:50/255.0f alpha:1];
            break;
        case 2:
            //red theme
            self.mainColor = [UIColor colorWithRed:227/255.0f green:85/255.0f blue:34/255.0f alpha:1];
            self.valueBackgroundColor = [UIColor colorWithRed:224/255.0f green:187/255.0f blue:167/255.0f alpha:1];
            self.valueFontColor = [UIColor colorWithRed:170/255.0f green:64/255.0f blue:26/255.0f alpha:1];
            break;
        case 3:
            //purple theme
            self.mainColor = [UIColor colorWithRed:102/255.0f green:45/255.0f blue:145/255.0f alpha:1];
            self.valueBackgroundColor = [UIColor colorWithRed:194/255.0f green:171/255.0f blue:221/255.0f alpha:1];
            self.valueFontColor = [UIColor colorWithRed:77/255.0f green:34/255.0f blue:109/255.0f alpha:1];
            break;
        case 4:
            //brown theme
            self.mainColor = [UIColor colorWithRed:117/255.0f green:76/255.0f blue:36/255.0f alpha:1];
            self.valueBackgroundColor = [UIColor colorWithRed:200/255.0f green:183/255.0f blue:167/255.0f alpha:1];
            self.valueFontColor = [UIColor colorWithRed:88/255.0f green:57/255.0f blue:27/255.0f alpha:1];
            break;
        case 5:
            //orange theme
            self.mainColor = [UIColor colorWithRed:247/255.0f green:147/255.0f blue:30/255.0f alpha:1];
            self.valueBackgroundColor = [UIColor colorWithRed:252/255.0f green:212/255.0f blue:165/255.0f alpha:1];
            self.valueFontColor = [UIColor colorWithRed:185/255.0f green:110/255.0f blue:23/255.0f alpha:1];
            break;
        default:
            //blue theme  as default
            self.mainColor = [UIColor colorWithRed:63/255.0f green:169/255.0f blue:245/255.0f alpha:1];
            self.valueBackgroundColor = [UIColor colorWithRed:178/255.0f green:221/255.0f blue:251/255.0f alpha:1];
            self.valueFontColor = [UIColor colorWithRed:47/255.0f green:127/255.0f blue:184/255.0f alpha:1];
            break;
            
    }
            
}

- (void)dealloc 
{
    [mainColor release];
    [valueBackgroundColor release];
    [valueFontColor release];

    [super dealloc];
}

@end
