//
//  TestPageController.h
//  Gi2MO Monitor
//
//  Created by cyanide on 2/26/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ScrollViewController.h"
#import "MetroStyleColorSet.h"

@class FlipsideViewController;

@interface MetroStylePanelController : UIViewController
{
    IBOutlet UILabel	*imsName;
    IBOutlet UILabel	*imsLastUpdated;
    //main stats
	IBOutlet UILabel	*ideaNumber;
	IBOutlet UILabel	*commentNumber;
	IBOutlet UILabel	*contestNumber;
	IBOutlet UILabel	*reviewNumber;

    //main stats diff
	IBOutlet UILabel	*ideaNumberDiff;
	IBOutlet UILabel	*commentNumberDiff;
	IBOutlet UILabel	*contestNumberDiff;
	IBOutlet UILabel	*reviewNumberDiff;
    
	IBOutlet UILabel	*ideaNumberDiffIcon;
	IBOutlet UILabel	*commentNumberDiffIcon;
	IBOutlet UILabel	*contestNumberDiffIcon;
	IBOutlet UILabel	*reviewNumberDiffIcon;
    
    //icons that show when diff tracking is turned off
	IBOutlet UIImageView	*ideaNumberDiffIconOff;
	IBOutlet UIImageView	*commentNumberDiffIconOff;
	IBOutlet UIImageView	*contestNumberDiffIconOff;
	IBOutlet UIImageView	*reviewNumberDiffIconOff;
    
    //diff status bar (shows time passed between updates)
	IBOutlet UILabel	*diffStatusBackground;
	IBOutlet UILabel	*diffStatusVerticalUnit;
	IBOutlet UILabel	*diffStatusVerticalTitle;
    IBOutlet UILabel	*diffStatushorizontalUnitTop;
	IBOutlet UILabel	*diffStatushorizontalUnitBottom;
    
    //last posted stats
    
    //last idea
	IBOutlet UILabel	*lastIdeaDate;
	IBOutlet UILabel	*lastIdeaTitle;
	IBOutlet UILabel	*lastIdeaAuthor;
    //last comment
	IBOutlet UILabel	*lastCommentDate;
	IBOutlet UILabel	*lastCommentTitle;
	IBOutlet UILabel	*lastCommentAuthor;
    //last contest
	IBOutlet UILabel	*lastContestDate;
	IBOutlet UILabel	*lastContestTitle;
	IBOutlet UILabel	*lastContestAuthor;
    
    IBOutlet UIImageView *refreshAnimatedImage;
    IBOutlet UIButton *refreshButton;
    
    //status info
    IBOutlet UIImageView	*connectionStatus;
    
    //other gui background placeholders
    IBOutlet UILabel	*imsNameBackground;
	IBOutlet UILabel	*ideaNumberTitle;
	IBOutlet UILabel	*commentNumberTitle;
	IBOutlet UILabel	*contestNumberTitle;
	IBOutlet UILabel	*reviewNumberTitle;
    
	IBOutlet UILabel	*lastIdeaTitleCaption;
	IBOutlet UILabel	*lastCommentTitleCaption;
	IBOutlet UILabel	*lastContestTitleCaption;
    
    //----------core data--------
    //    NSFetchedResultsController *fetchedResultsController;
    NSManagedObjectContext *managedObjectContext;
    ScrollViewController *parentScrollViewController;
    DataController *dataController;
    Settings *applicationSettings;
    int pageNumber; //page number indicates which entity from dataController should the Page display
    
    //thread queue for fetching RDFs
    NSOperationQueue *queue;
//    NSArray *panelColors;
    
}

@property (nonatomic, retain) UILabel *imsName;
@property (nonatomic, retain) UILabel *imsLastUpdated;

@property (nonatomic, retain) UILabel *ideaNumber;
@property (nonatomic, retain) UILabel *commentNumber;
@property (nonatomic, retain) UILabel *contestNumber;
@property (nonatomic, retain) UILabel *reviewNumber;

@property (nonatomic, retain) UILabel *ideaNumberDiff;
@property (nonatomic, retain) UILabel *commentNumberDiff;
@property (nonatomic, retain) UILabel *contestNumberDiff;
@property (nonatomic, retain) UILabel *reviewNumberDiff;

@property (nonatomic, retain) UIImageView *ideaNumberDiffIconOff;
@property (nonatomic, retain) UIImageView *commentNumberDiffIconOff;
@property (nonatomic, retain) UIImageView *contestNumberDiffIconOff;
@property (nonatomic, retain) UIImageView *reviewNumberDiffIconOff;

@property (nonatomic, retain) UILabel *ideaNumberDiffIcon;
@property (nonatomic, retain) UILabel *commentNumberDiffIcon;
@property (nonatomic, retain) UILabel *contestNumberDiffIcon;
@property (nonatomic, retain) UILabel *reviewNumberDiffIcon;

@property (nonatomic, retain) UILabel *diffStatusBackground;
@property (nonatomic, retain) UILabel *diffStatusVerticalUnit;
@property (nonatomic, retain) UILabel *diffStatusVerticalTitle;
@property (nonatomic, retain) UILabel *diffStatushorizontalUnitTop;
@property (nonatomic, retain) UILabel *diffStatushorizontalUnitBottom;

@property (nonatomic, retain) UILabel *lastIdeaDate;
@property (nonatomic, retain) UILabel *lastIdeaTitle;
@property (nonatomic, retain) UILabel *lastIdeaAuthor;

@property (nonatomic, retain) UILabel *lastCommentDate;
@property (nonatomic, retain) UILabel *lastCommentTitle;
@property (nonatomic, retain) UILabel *lastCommentAuthor;

@property (nonatomic, retain) UILabel *lastContestDate;
@property (nonatomic, retain) UILabel *lastContestTitle;
@property (nonatomic, retain) UILabel *lastContestAuthor;

@property (nonatomic, retain) UIImageView *connectionStatus;

@property (nonatomic, retain) UIImageView *refreshAnimatedImage;
@property (nonatomic, retain) UIButton *refreshButton;

//background elements
@property (nonatomic, retain) UILabel *imsNameBackground;
@property (nonatomic, retain) UILabel *ideaNumberTitle;
@property (nonatomic, retain) UILabel *commentNumberTitle;
@property (nonatomic, retain) UILabel *contestNumberTitle;
@property (nonatomic, retain) UILabel *reviewNumberTitle;

@property (nonatomic, retain) UILabel *lastIdeaTitleCaption;
@property (nonatomic, retain) UILabel *lastCommentTitleCaption;
@property (nonatomic, retain) UILabel *lastContestTitleCaption;


//color defs
//@property (nonatomic, retain) NSArray *panelColors;

// core data
//@property (nonatomic, retain) NSFetchedResultsController *fetchedResultsController;
@property (nonatomic, retain) NSManagedObjectContext *managedObjectContext;
@property (nonatomic, retain) DataController *dataController;
@property (nonatomic, retain) Settings *applicationSettings;

@property (assign, nonatomic) ScrollViewController *parentScrollViewController;

//threading
@property (nonatomic, retain) NSOperationQueue *queue;

- (id)initWithPageNumber:(int)page;
- (IBAction)showInfo:(id)sender;
- (IBAction) resyncStatistocsAction:(id)sender;

- (void) updateStatistics;
- (void) fetchRDFStatistics;


@end
