//
//  TestPageController.m
//  Gi2MO Monitor
//
//  Created by cyanide on 2/26/12.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "MetroStylePanelController.h"
#import "XMLReader.h"
#import "IdeaManagementStatus.h"

#import "IMS.h"
#import "Idea.h"
#import "Contest.h"
#import "Comment.h"
#import "User.h"
#import "ImsHistory.h"

#import "Settings.h"

#import "FetchRDFOperation.h"

#import "MetroStyleColorSet.h"

@implementation MetroStylePanelController

@synthesize	imsName;
@synthesize imsNameBackground;
@synthesize imsLastUpdated;

@synthesize	ideaNumber;
@synthesize	commentNumber;
@synthesize	contestNumber;
@synthesize	reviewNumber;

@synthesize	ideaNumberDiff;
@synthesize	commentNumberDiff;
@synthesize	contestNumberDiff;
@synthesize	reviewNumberDiff;

@synthesize	ideaNumberDiffIcon;
@synthesize	commentNumberDiffIcon;
@synthesize	contestNumberDiffIcon;
@synthesize	reviewNumberDiffIcon;

@synthesize	ideaNumberDiffIconOff;
@synthesize	commentNumberDiffIconOff;
@synthesize	contestNumberDiffIconOff;
@synthesize	reviewNumberDiffIconOff;

@synthesize diffStatusBackground;
@synthesize diffStatusVerticalUnit;
@synthesize diffStatusVerticalTitle;
@synthesize diffStatushorizontalUnitTop;
@synthesize diffStatushorizontalUnitBottom;

@synthesize	lastIdeaDate;
@synthesize	lastIdeaTitle;
@synthesize	lastIdeaAuthor;

@synthesize	lastCommentDate;
@synthesize	lastCommentTitle;
@synthesize	lastCommentAuthor;

@synthesize connectionStatus;

@synthesize	lastContestDate;
@synthesize	lastContestTitle;
@synthesize	lastContestAuthor;
@synthesize refreshAnimatedImage;
@synthesize refreshButton;

//backhround UI elements


@synthesize	ideaNumberTitle;
@synthesize	commentNumberTitle;
@synthesize	contestNumberTitle;
@synthesize	reviewNumberTitle;

@synthesize	lastIdeaTitleCaption;
@synthesize	lastCommentTitleCaption;
@synthesize	lastContestTitleCaption;


//core data
@synthesize managedObjectContext;
//@synthesize fetchedResultsController
@synthesize parentScrollViewController;
@synthesize dataController;
@synthesize applicationSettings;
@synthesize queue;

//colors 
//@synthesize panelColors;


- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (id)initWithPageNumber:(int)page {
    if (self = [super initWithNibName:@"MetroStylePanelController" bundle:nil])    {
        pageNumber = page;
        //setup notification center
        
        queue = [[NSOperationQueue alloc] init];
        
        [[NSNotificationCenter defaultCenter] addObserver:self 
                                                 selector:@selector(updateAnswer:) 
                                                     name:[NSString stringWithFormat:@"rdfDownloadFinished forStatusPage: %d", pageNumber]
                                                   object:nil];
    }
    return self;
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}


#pragma mark - View lifecycle

- (void)viewDidLoad
{
    //color definitions
    
    //re-position & color UI elements
    MetroStyleColorSet *metroStyleColorSet = [[MetroStyleColorSet alloc] init];
    int colorIndex = pageNumber % metroStyleColorSet.getColorSetsCount;
    [metroStyleColorSet setColorSet:colorIndex];
    NSLog (@"Color number is %d for page number %d",colorIndex,pageNumber);
    
    [imsName setTransform:CGAffineTransformMakeRotation(-M_PI / 2)];
    [imsName setFrame: CGRectMake(20,25,43,407)];
    
    [imsNameBackground setTransform:CGAffineTransformMakeRotation(-M_PI / 2)];
    [imsNameBackground setFrame: CGRectMake(20,18,43,414)];
    
    //set colors
    [imsNameBackground setBackgroundColor: metroStyleColorSet.mainColor];
    [imsName setBackgroundColor: metroStyleColorSet.mainColor];
    [diffStatusBackground setBackgroundColor: metroStyleColorSet.mainColor];
    [diffStatushorizontalUnitBottom setBackgroundColor: metroStyleColorSet.mainColor];
    [diffStatusVerticalTitle setBackgroundColor: metroStyleColorSet.mainColor];
    [diffStatusVerticalUnit setBackgroundColor: metroStyleColorSet.mainColor];
    
    [ideaNumberTitle setBackgroundColor: metroStyleColorSet.mainColor];
    [ideaNumber setBackgroundColor: metroStyleColorSet.valueBackgroundColor];
    [ideaNumber setTextColor: metroStyleColorSet.valueFontColor];
    
    [commentNumberTitle setBackgroundColor: metroStyleColorSet.mainColor];
    [commentNumber setBackgroundColor: metroStyleColorSet.valueBackgroundColor];
    [commentNumber setTextColor: metroStyleColorSet.valueFontColor];
    
    [contestNumberTitle setBackgroundColor: metroStyleColorSet.mainColor];
    [contestNumber setBackgroundColor: metroStyleColorSet.valueBackgroundColor];
    [contestNumber setTextColor: metroStyleColorSet.valueFontColor];
    
    [reviewNumberTitle setBackgroundColor: metroStyleColorSet.mainColor];
    [reviewNumber setBackgroundColor: metroStyleColorSet.valueBackgroundColor];
    [reviewNumber setTextColor: metroStyleColorSet.valueFontColor];
    
    [lastIdeaTitleCaption setBackgroundColor: metroStyleColorSet.mainColor];
    [lastCommentTitleCaption setBackgroundColor: metroStyleColorSet.mainColor];
    [lastContestTitleCaption setBackgroundColor: metroStyleColorSet.mainColor];
    
    //hide/ show icons and labels for value change monitoring (increase / decrese of ideas)
    NSLog(@"App is in diff mode of %d",[self.applicationSettings.diffMode intValue]);
    if ([self.applicationSettings.diffMode intValue] == 0) {
        //hide diff values 
        [self.ideaNumberDiff setHidden:YES];
        [self.commentNumberDiff setHidden:YES];
        [self.contestNumberDiff setHidden:YES];
        [self.reviewNumberDiff setHidden:YES];
        
        [self.ideaNumberDiffIcon setHidden:YES];
        [self.commentNumberDiffIcon setHidden:YES];
        [self.contestNumberDiffIcon setHidden:YES];
        [self.reviewNumberDiffIcon setHidden:YES];
        //show icon placeholders
        [self.ideaNumberDiffIconOff setHidden:NO];
        [self.commentNumberDiffIconOff setHidden:NO];
        [self.contestNumberDiffIconOff setHidden:NO];
        [self.reviewNumberDiffIconOff setHidden:NO];
        
        //hide status bar
        [diffStatusBackground setHidden:YES];
        [diffStatusVerticalTitle setHidden:YES];
        [diffStatusVerticalUnit setHidden:YES];
        [diffStatushorizontalUnitBottom setHidden:YES];
    } else
    {
        //hide icon placeholders
        [self.ideaNumberDiffIconOff setHidden:YES];
        [self.commentNumberDiffIconOff setHidden:YES];
        [self.contestNumberDiffIconOff setHidden:YES];
        [self.reviewNumberDiffIconOff setHidden:YES];
        //show diff values 
        [self.ideaNumberDiff setHidden:NO];
        [self.commentNumberDiff setHidden:NO];
        [self.contestNumberDiff setHidden:NO];
        [self.reviewNumberDiff setHidden:NO];
        
        [self.ideaNumberDiffIcon setHidden:NO];
        [self.commentNumberDiffIcon setHidden:NO];
        [self.contestNumberDiffIcon setHidden:NO];
        [self.reviewNumberDiffIcon setHidden:NO];
        
        //show status bar
        [imsName setFrame: CGRectMake(20,25,43,320)]; //cut ims name bar
        [imsNameBackground setFrame: CGRectMake(20,18,43,330)];
//        [imsNameBackground setHidden:YES];
        
        [diffStatusBackground setTransform:CGAffineTransformMakeRotation(-M_PI / 2)];
        [diffStatusBackground setFrame: CGRectMake(20,355,43,74)];
        [diffStatusBackground setHidden:NO];
        
        [diffStatusVerticalTitle setTransform:CGAffineTransformMakeRotation(-M_PI / 2)];
        [diffStatusVerticalTitle setFrame: CGRectMake(23,359,22,38)];
        [diffStatusVerticalTitle setHidden:NO];
        
        [diffStatusVerticalUnit setTransform:CGAffineTransformMakeRotation(-M_PI / 2)];
        [diffStatusVerticalUnit setFrame: CGRectMake(41,359,16,38)];
        [diffStatusVerticalUnit setHidden:NO];
        
        //[diffStatushorizontalUnitBottom setTransform:CGAffineTransformMakeRotation(-M_PI / 2)];
        [diffStatushorizontalUnitBottom setFrame: CGRectMake(26,397,31,32)];
        [diffStatushorizontalUnitBottom setHidden:NO];
    } 
    
    [self updateStatistics];
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    //pageNumberLabel.text = [NSString stringWithFormat:@"Page %d", pageNumber + 1];
    //self.view.backgroundColor = [TestPageController testPageControllerColorWithIndex:pageNumber];
    
    
    if ([parentScrollViewController.applicationSettings.autorefreshType intValue] == 2) //automatically fetch RDF and update display
    {
        //perform fetch only if last update was more than 1 hour ago
        IMS *ims = [dataController objectInListAtIndex: pageNumber];
        
        NSTimeInterval timeInt = [ims.dateAdded timeIntervalSinceNow];
        NSLog(@"Time internval for page: %i is: %f", pageNumber, timeInt); //timeInt < -60 &&
        if (refreshButton.hidden == NO) { //check if update has been already fired
            NSLog(@"update event fired!");
            [self resyncStatistocsAction: self];
        }
    }
}

- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

#pragma mark - Flipside View

- (void)flipsideViewControllerDidFinish:(FlipsideViewController *)controller
{
    [self dismissModalViewControllerAnimated:YES];
}

- (IBAction)showInfo:(id)sender
{    
    /*
     FlipsideViewController *controller = [[[FlipsideViewController alloc] initWithNibName:@"FlipsideViewController" bundle:nil] autorelease];
     // FlipsideViewController *controller = [[[FlipsideViewController alloc] initWithStyle: UITableViewStylePlain] autorelease];
     
     controller.delegate = self;
     controller.managedObjectContext = self.managedObjectContext;
     
     controller.modalTransitionStyle = UIModalTransitionStyleFlipHorizontal;
     [self presentModalViewController:controller animated:YES];
     */
    parentScrollViewController.showInfo;
}


- (IBAction)resyncStatistocsAction:(id)sender
{    
    //start button animation
    int numberOfFrames = 8;
    NSMutableArray *imagesArray = [NSMutableArray arrayWithCapacity:numberOfFrames];
    for (int i=1; numberOfFrames > i; ++i)
    {
        //[imagesArray addObject:[UIImage imageNamed: [NSString stringWithFormat:@"refresh_icon_animated.gif"]]];
        //        NSLog([NSString stringWithFormat:@"refresh_icon_animated%d.png", i]);
        [imagesArray addObject:[UIImage imageNamed: [NSString stringWithFormat:@"refresh_icon_animated%d.png", i]]]; //
    }
    
    
    //UIImageView *anImageView = [[[UIImageView alloc] initWithFrame:CGRectMake(40,100,250,188)] autorelease];
    //[self.view addSubview:anImageView];
    refreshAnimatedImage.animationImages = imagesArray; 
    refreshAnimatedImage.animationDuration = 0.8;
    refreshAnimatedImage.hidden = NO;
    refreshButton.hidden = YES;
    [refreshAnimatedImage startAnimating];
    //[refreshButton setImage:btnImage forState:UIControlStateNormal];
    
    //test bcg thread running
    // Create our operation and send it to the service
    IMS *ims = [dataController objectInListAtIndex: pageNumber];
    
    if (ims == nil) return;
            
    FetchRDFOperation *operation = [[FetchRDFOperation alloc]init];
    operation.url = ims.url;
    operation.pageNumber = pageNumber;
    
    [[self queue] addOperation:operation];
    // memory management 
    [operation release];
    //[ims release];
    imsLastUpdated.text = @"Updating ..."; 
    ///end of test
    
    //fetch RDF
    //[self fetchRDFStatistics];
    //change outlets
    //[self updateStatistics];
    
    //refresh view
    //[super viewDidLoad];
    //[refreshAnimatedImage stopAnimating];
    //refreshAnimatedImage.hidden = YES;
    //refreshButton.hidden = NO;
    
}


//custom methods

//update the view with statistics from core data object
- (void) updateStatistics
{
    
    IMS *ims = [dataController objectInListAtIndex: pageNumber];
    
    if (ims == nil) return; //if the object does not exist return nil
    
    imsName.text = ims.title;
    
    ideaNumber.text = [NSString stringWithFormat:@"%@", ims.hasIdeaCount];
    commentNumber.text = [NSString stringWithFormat:@"%@", ims.hasCommentCount];
    contestNumber.text = [NSString stringWithFormat:@"%@", ims.hasContestCount];
    reviewNumber.text = [NSString stringWithFormat:@"%@", ims.hasReviewCount];
    
    if (!([self.applicationSettings.diffMode intValue] == 0)) {
        //compute difference since last time
        int ideaCountDiff = 0;
        int commentCountDiff = 0;
        int contestCountDiff = 0;
        int reviewCountDiff = 0;
        
        if ([self.applicationSettings.diffMode intValue] == 1) {
            ideaCountDiff = [ims.hasIdeaCount intValue] - [ims.previousIdeaCount intValue];
            commentCountDiff = [ims.hasCommentCount intValue] - [ims.previousCommentCount intValue];
            contestCountDiff = [ims.hasContestCount intValue] - [ims.previousContestCount intValue];
            reviewCountDiff = [ims.hasReviewCount intValue] - [ims.previousReviewCount intValue];
        } else if ([self.applicationSettings.diffMode intValue] == 2) {
            ideaCountDiff = [ims.hasIdeaCount intValue] - [ims.hasHistory.dayIdeaCount intValue];
            commentCountDiff = [ims.hasCommentCount intValue] - [ims.hasHistory.dayCommentCount intValue];
            contestCountDiff = [ims.hasContestCount intValue] - [ims.hasHistory.dayContestCount intValue];
            reviewCountDiff = [ims.hasReviewCount intValue] - [ims.hasHistory.dayReviewCount intValue];
        } else if ([self.applicationSettings.diffMode intValue] == 3) {
            ideaCountDiff = [ims.hasIdeaCount intValue] - [ims.hasHistory.weekIdeaCount intValue];
            commentCountDiff = [ims.hasCommentCount intValue] - [ims.hasHistory.weekCommentCount intValue];
            contestCountDiff = [ims.hasContestCount intValue] - [ims.hasHistory.weekContestCount intValue];
            reviewCountDiff = [ims.hasReviewCount intValue] - [ims.hasHistory.weekReviewCount intValue];
        } else if ([self.applicationSettings.diffMode intValue] == 4) {
            ideaCountDiff = [ims.hasIdeaCount intValue] - [ims.hasHistory.monthIdeaCount intValue];
            commentCountDiff = [ims.hasCommentCount intValue] - [ims.hasHistory.monthCommentCount intValue];
            contestCountDiff = [ims.hasContestCount intValue] - [ims.hasHistory.monthContestCount intValue];
            reviewCountDiff = [ims.hasReviewCount intValue] - [ims.hasHistory.monthReviewCount intValue];
        } else if ([self.applicationSettings.diffMode intValue] == 5) {
            ideaCountDiff = [ims.hasIdeaCount intValue] - [ims.hasHistory.yearIdeaCount intValue];
            commentCountDiff = [ims.hasCommentCount intValue] - [ims.hasHistory.yearCommentCount intValue];
            contestCountDiff = [ims.hasContestCount intValue] - [ims.hasHistory.yearContestCount intValue];
            reviewCountDiff = [ims.hasReviewCount intValue] - [ims.hasHistory.yearReviewCount intValue];
        }
        
        NSString *ideaCountDiffString = @"";
        NSString *commentCountDiffString = @"";
        NSString *contestCountDiffString = @"";
        NSString *reviewCountDiffString = @"";
        
        NSString *ideaCountDiffIconString = @"";
        NSString *commentCountDiffIconString = @"";
        NSString *contestCountDiffIconString = @"";
        NSString *reviewCountDiffIconString = @"";
        
        //formmat idea count strings
        if (ideaCountDiff > 0) {  
            ideaCountDiffString = [NSString stringWithFormat:@"+%d", ideaCountDiff];
            ideaCountDiffIconString = @"+";
        }
        else {
            ideaCountDiffString = [NSString stringWithFormat:@"%d", ideaCountDiff];
            ideaCountDiffIconString = @"-";
        }
        if (ideaCountDiff == 0) { ideaCountDiffString = @""; ideaCountDiffIconString = @"~"; }
        //formmat comment count strings
        if (commentCountDiff > 0) {
            commentCountDiffString = [NSString stringWithFormat:@"+%d", commentCountDiff];
            commentCountDiffIconString = @"+";
        }
        else {
            commentCountDiffString = [NSString stringWithFormat:@"%d", commentCountDiff];   
            commentCountDiffIconString = @"-";
        }
        if (commentCountDiff == 0) { commentCountDiffString = @""; commentCountDiffIconString = @"~"; }
        //formmat comment count strings
        if (contestCountDiff > 0) {
            contestCountDiffString = [NSString stringWithFormat:@"+%d", contestCountDiff];
            contestCountDiffIconString = @"+";
        }
        else {
            contestCountDiffString = [NSString stringWithFormat:@"%d", contestCountDiff];
            contestCountDiffIconString = @"-";
        }
        if (contestCountDiff == 0) { contestCountDiffString =@""; contestCountDiffIconString = @"~"; }
        //formmat comment count strings
        if (reviewCountDiff > 0) {
            reviewCountDiffString = [NSString stringWithFormat:@"+%d", reviewCountDiff];
            reviewCountDiffIconString = @"+";
        }
        else {
            reviewCountDiffString = [NSString stringWithFormat:@"%d", reviewCountDiff];
            reviewCountDiffIconString = @"-";
        }
        if (reviewCountDiff == 0) { reviewCountDiffString = @""; reviewCountDiffIconString = @"~"; }
        
        //compute new positions of icons
        
        int number = ideaCountDiff;
        int digits = 0; 
        if (number == 0) digits = 1;
        while (number != 0) { number /= 10; digits++; }
        int ideaCountDiffIconPositionX = 256 - (digits - 1)*9.5;

        number = commentCountDiff;
        digits = 0; 
        if (number == 0) digits = 1;
        while (number != 0) { number /= 10; digits++; }
        int commentCountDiffIconPositionX = 256 - (digits - 1)*9.5;
        
        number = contestCountDiff;
        digits = 0; 
        if (number == 0) digits = 1;
        while (number != 0) { number /= 10; digits++; }    
        int contestCountDiffIconPositionX = 256 - (digits - 1)*9.5;
        
        number = reviewCountDiff;
        digits = 0; 
        if (number == 0) digits = 1;
        while (number != 0) { number /= 10; digits++; }        
        int reviewCountDiffIconPositionX = 256 - (digits - 1)*9.5;
        
        //[imsName setFrame: CGRectMake(20,25,43,407)];
        //end of diff calculations
        
        //set diffs UILabels
        ideaNumberDiff.text = ideaCountDiffString;
        commentNumberDiff.text = commentCountDiffString;
        contestNumberDiff.text = contestCountDiffString;
        reviewNumberDiff.text = reviewCountDiffString;
        
        ideaNumberDiffIcon.text = ideaCountDiffIconString;
        commentNumberDiffIcon.text = commentCountDiffIconString;
        contestNumberDiffIcon.text = contestCountDiffIconString;
        reviewNumberDiffIcon.text = reviewCountDiffIconString;
        
        NSLog(@"new positions: %d %d %d %d", ideaCountDiffIconPositionX, commentCountDiffIconPositionX, contestCountDiffIconPositionX, reviewCountDiffIconPositionX);
        [ideaNumberDiffIcon setFrame: CGRectMake(ideaCountDiffIconPositionX, 7,41,46)];
        [commentNumberDiffIcon setFrame: CGRectMake(commentCountDiffIconPositionX,59,41,46)];
        [contestNumberDiffIcon setFrame: CGRectMake(contestCountDiffIconPositionX,113,41,46)];
        [reviewNumberDiffIcon setFrame: CGRectMake(reviewCountDiffIconPositionX,167,41,46)];
        
        //set DFF status bar values
        
        //testtestset
        //show status bar
        [imsName setFrame: CGRectMake(20,25,43,320)]; //cut ims name bar
        [imsNameBackground setFrame: CGRectMake(20,18,43,330)];
        //        [imsNameBackground setHidden:YES];
        
        [diffStatusBackground setTransform:CGAffineTransformMakeRotation(-M_PI / 2)];
        [diffStatusBackground setFrame: CGRectMake(20,355,43,74)];
        [diffStatusBackground setHidden:NO];
        
        [diffStatusVerticalTitle setTransform:CGAffineTransformMakeRotation(-M_PI / 2)];
        [diffStatusVerticalTitle setFrame: CGRectMake(23,359,22,38)];
        [diffStatusVerticalTitle setHidden:NO];
        
        [diffStatusVerticalUnit setTransform:CGAffineTransformMakeRotation(-M_PI / 2)];
        [diffStatusVerticalUnit setFrame: CGRectMake(41,359,16,38)];
        [diffStatusVerticalUnit setHidden:NO];
        
        //[diffStatushorizontalUnitBottom setTransform:CGAffineTransformMakeRotation(-M_PI / 2)];
        [diffStatushorizontalUnitBottom setFrame: CGRectMake(26,397,31,32)];
        [diffStatushorizontalUnitBottom setHidden:NO];
        
        if ([self.applicationSettings.diffMode intValue] == 1) { //calculate time since manual update
                
            //reposition UILabels
            [diffStatusVerticalTitle setFrame: CGRectMake(23,359,22,38)];
            [diffStatusVerticalUnit setFrame: CGRectMake(41,359,16,38)];
            [diffStatushorizontalUnitBottom setFrame: CGRectMake(26,397,31,32)];
            diffStatushorizontalUnitBottom.font = [UIFont systemFontOfSize:29];
            
            //calculate diff between dates    
            NSCalendar *sysCalendar = [NSCalendar currentCalendar];
            unsigned int unitFlags = NSHourCalendarUnit | NSMinuteCalendarUnit | NSSecondCalendarUnit | NSDayCalendarUnit | NSMonthCalendarUnit | NSYearCalendarUnit;
            
            NSDateComponents *breakdownInfo = [sysCalendar components:unitFlags fromDate:ims.previousDateAdded  toDate:ims.dateAdded options:0];
            
            NSLog(@"Break down: %dmin %dhours %ddays %dmoths",[breakdownInfo minute], [breakdownInfo hour], [breakdownInfo day], [breakdownInfo month]);
            
            if ([breakdownInfo year] != 0 ) //if interval is more than 1 day
            {
                diffStatusVerticalUnit.text = @"years";
                diffStatushorizontalUnitBottom.text = [NSString localizedStringWithFormat:@"%.2i", [breakdownInfo year]];
            } else if ([breakdownInfo month] != 0 )
            {
                diffStatusVerticalUnit.text = @"month";
                diffStatushorizontalUnitBottom.text = [NSString localizedStringWithFormat:@"%.2i", [breakdownInfo month]];
            } else if ([breakdownInfo day] != 0 )
            {
                diffStatusVerticalUnit.text = @"days";
                diffStatushorizontalUnitBottom.text = [NSString localizedStringWithFormat:@"%.2i", [breakdownInfo day]];
            } else if ([breakdownInfo hour] != 0 )
            {
                diffStatusVerticalUnit.text = @"hours";
                diffStatushorizontalUnitBottom.text = [NSString localizedStringWithFormat:@"%.2i", [breakdownInfo hour]];
            } else if ([breakdownInfo minute] != 0 )
            {
                diffStatusVerticalUnit.text = @"min.";
                diffStatushorizontalUnitBottom.text = [NSString localizedStringWithFormat:@"%.2i", [breakdownInfo minute]];
            } else if ([breakdownInfo second] != 0 )
            {
                diffStatusVerticalUnit.text = @"sec.";
                diffStatushorizontalUnitBottom.text = [NSString localizedStringWithFormat:@"%.2i", [breakdownInfo second]];
            } else //if dates are exactly the same
            {
                //hide status bar
                [diffStatusBackground setHidden:YES];
                [diffStatusVerticalTitle setHidden:YES];
                [diffStatusVerticalUnit setHidden:YES];
                [diffStatushorizontalUnitBottom setHidden:YES];
                [imsName setTransform:CGAffineTransformMakeRotation(-M_PI / 2)];
                [imsName setFrame: CGRectMake(20,25,43,407)];
                
                [imsNameBackground setTransform:CGAffineTransformMakeRotation(-M_PI / 2)];
                [imsNameBackground setFrame: CGRectMake(20,18,43,414)];
                //diffStatusVerticalUnit.text = @"sec.";
                //diffStatushorizontalUnitBottom.text = [NSString localizedStringWithFormat:@"%.2i", 0];            
            }
        } else {
            [diffStatusVerticalTitle setFrame: CGRectMake(23,367,22,38)];
            [diffStatusVerticalUnit setFrame: CGRectMake(41,367,16,38)];
            [diffStatushorizontalUnitBottom setFrame: CGRectMake(26,405,31,20)];
            diffStatushorizontalUnitBottom.font = [UIFont boldSystemFontOfSize:11];
            diffStatushorizontalUnitBottom.text = @"LAST";
         
            if ([self.applicationSettings.diffMode intValue] == 2) {
                diffStatusVerticalUnit.text = @"day";
            } else if ([self.applicationSettings.diffMode intValue] == 3) {
                diffStatusVerticalUnit.text = @"week";
            } else if ([self.applicationSettings.diffMode intValue] == 4) {
                diffStatusVerticalUnit.text = @"month";
            } else if ([self.applicationSettings.diffMode intValue] == 5) {
                diffStatusVerticalUnit.text = @"year";
            }
        }
    }
    //set latest content summary
    lastIdeaTitle.text = ims.hasIdea.title;
    lastIdeaDate.text = ims.hasIdea.created;
    lastIdeaAuthor.text = ims.hasIdea.hasCreator.accountName;
    
    lastCommentTitle.text = ims.hasComment.content;
    lastCommentDate.text = ims.hasComment.created;
    lastCommentAuthor.text = ims.hasComment.hasCreator.accountName;
    
    lastContestTitle.text = ims.hasContest.title;
    lastContestDate.text =  ims.hasContest.created;
    lastContestAuthor.text = ims.hasContest.hasCreator.accountName;
    
    NSDateFormatter* dateFormatter = [[[NSDateFormatter alloc] init] autorelease];
    dateFormatter.dateFormat = @"yyyy-MM-dd HH:mm";     
    
    imsLastUpdated.text = [NSString stringWithFormat:@"Updated %@", [dateFormatter stringFromDate: ims.dateAdded]];
    imsLastUpdated.hidden = NO;
}

//fetch the RDF and update core data objects
- (void) fetchRDFStatistics
{
    //ideaNumber.text = [NSString stringWithFormat: @"keks"];
    //IMS *ims = [dataController objectInListAtIndex: pageNumber];
    
    //testing
    //XMLReader *anInst = [[[XMLReader alloc] init] autorelease];
    
    //parse XML
    /*        
     NSURL *url = [[NSURL alloc] initWithString:@"http://192.168.1.33/~cyanide/gi2mo_ideas.rdf"];
     
     //NSURL *url = [[NSURL alloc] initWithString:@"http://ideas.gi2mo.org/gi2mo_ideas.rdf"];
     //NSURL *url = [[NSURL alloc] initWithString:@"http://192.168.1.33/~cyanide/Books2.xml"];
     NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithContentsOfURL:url]; */
    
    //alternative with timeout
    
    NSString *u = [NSString stringWithFormat:@"http://ideas.gi2mo.org/gi2mo_ideas666.rdf"];
    
    //NSString *u = ims.url; //[NSString stringWithFormat:@"%@",ims.url];
    
    //    NSString *u = [NSString stringWithFormat:@"http://192.168.1.33/~cyanide/gi2mo_ideas666.rdf"];
    //    NSString *u = [NSString stringWithFormat:@"http://192.168.1.33/~cyanide/gi2mo_ideas.rdf"];
    NSURLRequest* chRequest = [NSURLRequest requestWithURL:[NSURL URLWithString:u] cachePolicy: NSURLRequestReloadIgnoringCacheData timeoutInterval:1000];
    NSError* theError;
    NSData* response = [NSURLConnection sendSynchronousRequest:chRequest returningResponse:nil error:&theError]; 
    
    NSXMLParser *xmlParser = [[NSXMLParser alloc] initWithData:response];
    
    //enable namespace parsing
    [xmlParser setShouldProcessNamespaces:YES];
    
    //Initialize the delegate.
    XMLReader *parser = [[XMLReader alloc] initXMLReader];
    
    //Set delegate
    [xmlParser setDelegate:parser];
    
    //Start parsing the XML file.
    BOOL success = [xmlParser parse];
    
    if(success && response!= nil)
    {
        NSLog(@"No Errors");
        [dataController updateData: parser.ideaManagementStatus AtIndex: pageNumber];
    }
    else
    {
        
        NSLog(@"Error Error Error!!!");
    }
}

- (void) updateAnswer:(NSNotification *)notification{
    // Make sure the updates get performed on the main thread
    if (NO==[NSThread isMainThread]){
        [self performSelectorOnMainThread:@selector(updateAnswer:) withObject:notification waitUntilDone:NO];
        return;
    }
    //[[self activityIndicator] stopAnimating];

    IdeaManagementStatus *imsStatus = [[notification userInfo] objectForKey:[NSString stringWithFormat:@"rdfDownloadFinished forStatusPage: %d", pageNumber]];
    //[[self answerLabel] setText:[NSString stringWithFormat:@"%d",[newNumber intValue]]];
    //NSLog(@"test message _ some thread just delivered results !: %@",imsStatus);
    if (imsStatus.transferSuccess == YES) {
        
        [dataController updateData: imsStatus AtIndex: pageNumber];
        [self updateStatistics];
        
        NSDateFormatter* dateFormatter = [[[NSDateFormatter alloc] init] autorelease];
        dateFormatter.dateFormat = @"yyyy-MM-dd HH:mm";     
        
        imsLastUpdated.text = [NSString stringWithFormat:@"Updated %@", [dateFormatter stringFromDate: [NSDate date]]];
        imsLastUpdated.hidden = NO;
        connectionStatus.hidden = YES;
    }
    else 
    { 
        connectionStatus.hidden = NO;
        IMS *ims = [dataController objectInListAtIndex: pageNumber];
        NSDateFormatter* dateFormatter = [[[NSDateFormatter alloc] init] autorelease];
        dateFormatter.dateFormat = @"yyyy-MM-dd HH:mm";     

        imsLastUpdated.text = [NSString stringWithFormat:@"Updated %@", [dateFormatter stringFromDate: ims.dateAdded]]; 
    }
    // make refresh button active again
    [refreshAnimatedImage stopAnimating];
    refreshAnimatedImage.hidden = YES;
    refreshButton.hidden = NO;
}

#pragma mark -
#pragma mark Memory management

- (void)dealloc {
    //    [fetchedResultsController release];
    [managedObjectContext release];
    [queue release];
    //    [addingManagedObjectContext release];
    [super dealloc];
}

@end
